function a22 = calIntPts(Dphi_b, a21, a23)
%CALCULATEINTERPOINTS Will calculate intermediate points, such that the
%derivative of one phase carries smoothly over to the next phase

global degree

switch degree
    case 2,
        if a23 >= a21
            a22 = 0.5 * Dphi_b * (a23 - a21) + a21;
        else
            if Dphi_b >= 0
                a22 = -(0.5 * Dphi_b * (a23 - a21)) + a21;
            else
                a22 = 0.5 * abs(Dphi_b) * (a23 - a21) + a21;
            end
        end
        
    case 3,
        if a23 >= a21
            a22 = (1/3) * Dphi_b * (a23 - a21) + a21;
        else
            if Dphi_b >= 0
                a22 = -((1/3) * Dphi_b * (a23 - a21)) + a21;
            else
                a22 = (1/3) * abs(Dphi_b) * (a23 - a21) + a21;
            end
        end
end

end

