clc
clear all
close all

%% Declare global parameters
global Coeff
global theta_b theta_e
global degree
global l m s I
global m1 m2 m3 m4 m5 s1 s2 s3 s4 s5 L1 L2 L3 L4 L5 I1 I2 I3 I4 I5 g
global y_e x_e

degree = 1;
[g,L1,L2,L3,m1,m2,m3,I1,I2,I3,s1,s2,s3] = modelParameters();
L4 = L2; L5 = L1; m4 = m2; m5 = m1; I4 = I2; I5 = I1; s4 = s2; s5 = s1;
I = [I1 I2 I3 I4 I5];
s = [s1 s2 s3 s4 s5];
m = [m1 m2 m3 m4 m5];
l = [L1 L2 L3 L4 L5];
run motor_constants


P_c = 1000;
I_c = 0.1;
D_c = 10;


%% Phase 1
tic;
q1 = [2.79 -0.1 -2.4 -1.4 -1.194];
q2_e = [2.7 -0.4 -2.2 -1.3 -1.3705];%new

Coeff =[ 0         0;
        -0.1000   -0.3500;
        -2.4000   -2.2500;
        -1.4000   -1.0000;
        -1.1940   -1.4000];

theta_b = 2.7900;
theta_e = 2.9000;

y_e = 0;
x_e = 0;
x0_red_dyn = [q1(1)   0.001]; % pos, vel
theta_feasible_range = [pi 0];

run motors_initial_values_phase1

tspan = [0 2];
options = simset('MaxStep', 1e-2, 'AbsTol', 1e-6, 'RelTol', 1e-6);
sim('MASTER_newgait_phase1_ctrl',tspan, options, []);

state_vect = [x_red(:,1) phi2_5_res(:,1) phi2_5_res(:,2) phi2_5_res(:,3) phi2_5_res(:,4) x_red(:,2) Dphi2_5_res(:,1) Dphi2_5_res(:,2) Dphi2_5_res(:,3) Dphi2_5_res(:,4)];
state_vect1 = state_vect;
time = t_red;
phi_reference_values = phi2_5_reference;
Dphi_reference_values = Dphi2_5_reference;
u_signal = u_sig;
% DDstate = DDx_red;

states_trans1 = [state_vect1(size(state_vect1,1),1:5) state_vect1(size(state_vect1,1),6:10)];
toc;
%% Phase 2
tic;
theta_b = 2.9369;
theta_e = 2.7000;

Coeff = [0         0;
         -0.4338   -0.4000;
        -2.1997   -2.2000;
        -0.8659   -1.3000;
        -1.4691   -1.3705];

y_e = 0;
x_e = 0;
x0_red_dyn = [states_trans1(1) states_trans1(6)]; % pos, vel

run motors_initial_values_phase2

sim('MASTER_newgait_phase2_ctrl',tspan, options, []);

state_vect2 = [x_red(:,1) phi2_5_res(:,1) phi2_5_res(:,2) phi2_5_res(:,3) phi2_5_res(:,4) x_red(:,2) Dphi2_5_res(:,1) Dphi2_5_res(:,2) Dphi2_5_res(:,3) Dphi2_5_res(:,4)];
state_vect = [state_vect;state_vect2];
phi_reference_values = [phi_reference_values;phi2_5_reference];
Dphi_reference_values = [Dphi_reference_values;Dphi2_5_reference];
time = [time;t_red+time(size(time,1))];
u_signal = [u_signal;u_sig];
toc;

%% Phase 3
tic;
q3_b = [0.35 0.1 2.4 1.3 1.245];

theta_b = 0.3500;
theta_e = 0.2500;

Coeff =[0         0;
        0.1000    0.4000;
        2.4000    2.1500;
        1.3000    1.0000;
        1.2450    2.0000];
    
% foot_pos = calculatePoints(state_vect2(size(state_vect2,1),1:5), 0, 0);
y_e = 0;%foot_pos(6, 2); % or 0?
x_e = 0.1404;%foot_pos(6, 1);%0.1404;

x0_red_dyn = [q3_b(1) -0.001]; % pos, vel
run motors_initial_values_phase3
sim('MASTER_newgait_phase3_ctrl',tspan, options, []);

state_vect3 = [x_red(:,1) phi2_5_res(:,1) phi2_5_res(:,2) phi2_5_res(:,3) phi2_5_res(:,4) x_red(:,2) Dphi2_5_res(:,1) Dphi2_5_res(:,2) Dphi2_5_res(:,3) Dphi2_5_res(:,4)];
state_vect = [state_vect; state_vect3];
phi_reference_values = [phi_reference_values;phi2_5_reference];
Dphi_reference_values = [Dphi_reference_values;Dphi2_5_reference];
time = [time;t_red+time(size(time,1))];
u_signal = [u_signal;u_sig];

states_trans3 = [state_vect3(size(state_vect3,1),1:5) state_vect3(size(state_vect3,1),6:10)];
toc;
%% Phase 4
tic;
q4_e = [0.837592653589793 1.194 1.4 2.4 0.1];

theta_b = 0.2374;
theta_e = 0.8376;
Coeff =[0         0;
        0.4378    1.1940;
        2.1185    1.4000;
        0.9622    2.4000;
        2.0951    0.1000];

x0_red_dyn = [states_trans3(1) states_trans3(6)]; % pos, vel
run motors_initial_values_phase4
sim('MASTER_newgait_phase4_ctrl',tspan, options, []);

state_vect4 = [x_red(:,1) phi2_5_res(:,1) phi2_5_res(:,2) phi2_5_res(:,3) phi2_5_res(:,4) x_red(:,2) Dphi2_5_res(:,1) Dphi2_5_res(:,2) Dphi2_5_res(:,3) Dphi2_5_res(:,4)];
state_vect = [state_vect; state_vect4];
phi_reference_values = [phi_reference_values;phi2_5_reference];
Dphi_reference_values = [Dphi_reference_values;Dphi2_5_reference];
time = [time;t_red+time(size(time,1))];
u_signal = [u_signal;u_sig];

states_trans4 = [state_vect1(1,1:5) state_vect1(1,6:10)];
toc;
%% Plot
run plot_phaseplot
% run MASTER_plot_normal_forces