function [ inertias ] = fct_calc_load_inertias( phis )

global l s
global m2 m3 m4 m5 I2 I3 I4 I5

phi2 = phis(1);
phi3 = phis(2);
phi4 = phis(3);
phi5 = phis(4);

dist22 = l(2)-s(2);
dist23 = sqrt((l(2) + (l(3) - s(3)) * cos(phi3))^2 + ((l(3) - s(3)) * sin(phi3))^2);
dist24 = sqrt((l(2) + l(3) * cos(phi3) + s(4) * cos(phi3 + phi4))^2 + (l(3) * sin(phi3) + s(4) * sin(phi3 + phi4))^2);
dist25 = sqrt((l(2) + l(3) * cos(phi3) + l(4) * cos(phi3 + phi4) + s(5) * cos(phi3 + phi4 + phi5))^2 + (l(3) * sin(phi3) + l(4) * sin(phi3 + phi4) + s(5) * sin(phi3 + phi4 + phi5))^2);
dist33 = l(3) - s(3);
dist34 = sqrt((l(3) + s(4) * cos(phi4))^2 + (s(4) * sin(phi4))^2);
dist35 = sqrt((l(3) + l(4) * cos(phi4) + s(5) * cos(phi4 + phi5))^2 + (l(4) * sin(phi4) + s(5) * sin(phi4 + phi5))^2);
dist44 = s(4);
dist45 = sqrt((l(4) + s(5) * cos(phi5))^2 + (s(5) * sin(phi5))^2);
dist55 = s(5);


inertia2 = (I2 + m2 * dist22^2) + (I3 + m3 * dist23^2) + (I4 + m4 * dist24^2) + (I5 + m5 * dist25^2);
inertia3 = (I3 + m3 * dist33^2) + (I4 + m4 * dist34^2) + (I5 + m5 * dist35^2);
inertia4 = (I4 + m4 * dist44^2) + (I5 + m5 * dist45^2);
inertia5 = I5 + m5 * dist55^2;

inertias = [inertia2 inertia3 inertia4 inertia5];

end
