function [ torques ] = fct_calc_load_torques( phis )

global l s g
global m2 m3 m4 m5
global x_e y_e

theta = phis(1);
phi2 = phis(2);
phi3 = phis(3);
phi4 = phis(4);
phi5 = phis(5);

p_mc2 = [l(1)*cos(theta) + (l(2)-s(2))*cos(theta + phi2) + x_e, l(1)*sin(theta)+(l(2) - s(2))*sin(theta+phi2) + y_e];
p_mc3 = [l(1)*cos(theta) + l(2)*cos(theta+phi2) + (l(3)-s(3))*cos(theta+phi2+phi3) + x_e, l(1)*sin(theta) + l(2)*sin(theta+phi2) + (l(3)-s(3))*sin(theta+phi2+phi3) + y_e];
p_mc4 = [l(1)*cos(theta) + l(2)*cos(theta+phi2) + l(3)*cos(theta+phi2+phi3) + s(4)*cos(theta+phi2+phi3+phi4) + x_e, l(1)*sin(theta) + l(2)*sin(theta+phi2) + l(3)*sin(theta+phi2+phi3) + s(4)*sin(theta+phi2+phi3+phi4) + y_e];
p_mc5 = [l(1)*cos(theta) + l(2)*cos(theta+phi2) + l(3)*cos(theta+phi2+phi3) + l(4)*cos(theta+phi2+phi3+phi4) + s(5)*cos(theta+phi2+phi3+phi4+phi5) + x_e, l(1)*sin(theta) + l(2)*sin(theta+phi2) + l(3)*sin(theta+phi2+phi3) + l(4)*sin(theta+phi2+phi3+phi4) + s(5)*sin(theta+phi2+phi3+phi4+phi5) + y_e];

p_mc2_5 = [(m2*p_mc2(1) + m3*p_mc3(1) + m4*p_mc4(1) + m5*p_mc5(1))/(m2+m3+m4+m5), (m2*p_mc2(2) + m3*p_mc3(2) + m4*p_mc4(2) + m5*p_mc5(2))/(m2+m3+m4+m5)];
p_mc3_5 = [(m3*p_mc3(1) + m4*p_mc4(1) + m5*p_mc5(1))/(m3+m4+m5), (m3*p_mc3(2) + m4*p_mc4(2) + m5*p_mc5(2))/(m3+m4+m5)];
p_mc4_5 = [(m4*p_mc4(1) + m5*p_mc5(1))/(m4+m5), (m4*p_mc4(2) + m5*p_mc5(2))/(m4+m5)];
p_mc5_5 = [(m5*p_mc5(1))/(m5), (m5*p_mc5(2))/(m5)];

p2 = [l(1)*cos(theta) + x_e, l(1)*sin(theta) + y_e];
p3 = [l(1)*cos(theta) + l(2)*cos(theta+phi2) + x_e, l(1)*sin(theta) + l(2)*sin(theta+phi2) + y_e];
p4 = [l(1)*cos(theta) + l(2)*cos(theta+phi2) + l(3)*cos(theta+phi2+phi3) + x_e, l(1)*sin(theta) + l(2)*sin(theta+phi2) + l(3)*sin(theta+phi2+phi3) + y_e];
p5 = [l(1)*cos(theta) + l(2)*cos(theta+phi2) + l(3)*cos(theta+phi2+phi3) + l(4)*cos(theta+phi2+phi3+phi4) + x_e, l(1)*sin(theta) + l(2)*sin(theta+phi2) + l(3)*sin(theta+phi2+phi3) + l(4)*sin(theta+phi2+phi3+phi4) + y_e];

% Torque med distance lik distansen fra festepunktets x til x-koordinatet
% til massesenteret, vurder  putt in sin(vinkel) for  justere verdien

torque2 = (p_mc2_5(1) - p2(1))*g*(m2+m3+m4+m5);
torque3 = (p_mc3_5(1) - p3(1))*g*(m3+m4+m5);
torque4 = (p_mc4_5(1) - p4(1))*g*(m4+m5);
torque5 = (p_mc5_5(1) - p5(1))*g*(m5);

% figure(2)
% hold on
% xlabel('X')
% ylabel('Y')
% axis([-0.1 0.6 0 0.35])
% % plot(points(:,1),  points(:,2), 'k');
% % plot(p_mc1(1), p_mc1(2), 'k*');
% plot(p_mc2(1), p_mc2(2), 'k*');
% plot(p_mc3(1), p_mc3(2), 'k*');
% plot(p_mc4(1), p_mc4(2), 'k*');
% plot(p_mc5(1), p_mc5(2), 'k*');
% 
% % plot(p1(1), p1(2), 'ko');
% plot(p2(1), p2(2), 'ko');
% plot(p3(1), p3(2), 'ko');
% plot(p4(1), p4(2), 'ko');
% plot(p5(1), p5(2), 'ko');
% plot([-0.1 0.6],[0 0], 'k');
% 
% plot(p_mc2_5(1), p_mc2_5(2), 'r*');
% plot(p_mc3_5(1), p_mc3_5(2), 'b*');
% plot(p_mc4_5(1), p_mc4_5(2), 'y*');
% plot(p_mc5_5(1), p_mc5_5(2), 'm*');

torques = [torque2 torque3 torque4 torque5];

end