clc
clear all
close all

tic;
%% Declare global parameters
global Coeff
global theta_b theta_e
global degree
global l m s I
global m1 m2 m3 m4 m5 s1 s2 s3 s4 s5 L1 L2 L3 L4 L5 I1 I2 I3 I4 I5 g
global y_e x_e
global theta_0 dtheta_0

degree = 2;
[g,L1,L2,L3,m1,m2,m3,I1,I2,I3,s1,s2,s3] = modelParameters();
L4 = L2; L5 = L1; m4 = m2; m5 = m1; I4 = I2; I5 = I1; s4 = s2; s5 = s1;
I = [I1 I2 I3 I4 I5];
s = [s1 s2 s3 s4 s5];
m = [m1 m2 m3 m4 m5];
l = [L1 L2 L3 L4 L5];

run motor_constants

load path_coefficients/2deg_455cm_fine_ok.mat
load integral_lookup_table_phase1.mat
load integral_lookup_table_phase2.mat
load integral_lookup_table_phase3.mat
load integral_lookup_table_phase4.mat

%% Phase 1
q1 = [2.2 -1.3 -0.9 -0.90 -1.3];
q2_e = [2.1 -1.55 -0.55 -0.75 -1.61];
q3_e = [0 x_coeff(10) x_coeff(11) x_coeff(12) x_coeff(13)];

Coeff =[0         0         0;
        -1.3000   -1.4994   -1.2045;
        -0.9000   -0.7498   -0.7525;
        -0.9000   -0.7532   -0.7012;
        -1.3000   -1.5076   -1.7315];
    
theta_b = q1(1);
theta_e = 2.7;
y_e = 0;
x_e = 0;
x0_red_dyn = [q1(1)   x_coeff(1)]; % pos, vel    max 1.56 min 1.49
theta_feasible_range = [pi 0];
theta_0 = x0_red_dyn(1);
dtheta_0 = x0_red_dyn(2);
integral_initial_value = 0;

run motors_initial_values_phase1
%% Test av perturbed initial conditions
integral_initial_value = integral_initial_value;
motor2_pos = motor2_pos  +0.001;
motor2_vel = motor2_vel  +0.001;
motor3_pos = motor3_pos  +0.001;
motor3_vel = motor3_vel  +0.001;
motor4_pos = motor4_pos  +0.001;
motor4_vel = motor4_vel  +0.001;
motor5_pos = motor5_pos  +0.001;
motor5_vel = motor5_vel  +0.001;

K_lin = [0.0097  529.7798  -19.1812   27.4238  -13.4905   47.1890   -0.2638    1.1388   -0.5069;
    0.0019  -33.0216  536.9022  -42.3056   19.8392   -2.0508   46.2430   -1.7145    0.7655;
   -0.0068  -82.3883  -96.7908  560.2238  -25.2540   -4.1224   -4.4296   47.4427   -1.0760;
   -0.0080  -80.7595  -38.5045  -28.2862  536.3877   -4.0300   -2.1342   -1.2341   46.4661];
               
%%

tspan = [0 2];
options = simset('MaxStep', 1e-2, 'AbsTol', 1e-2, 'RelTol', 1e-2);
sim('MASTER_sim_transys_phase1_test_const_K2',tspan, options, []);

state_vect = [x_red(:,1) phi2_5_res(:,1) phi2_5_res(:,2) phi2_5_res(:,3) phi2_5_res(:,4) x_red(:,2) Dphi2_5_res(:,1) Dphi2_5_res(:,2) Dphi2_5_res(:,3) Dphi2_5_res(:,4)];
state_vect1 = state_vect;
time = t_red;
phi_reference_values = phi2_5_reference;
Dphi_reference_values = Dphi2_5_reference;
integral_values = integral_value;
u_signal = u_sig;
transverse_coordinates = trans_coordinates;
% ddtheta_sim_t = ddtheta_sim;

time_constant = time(size(time,1));

F = eye(5); % trivial transformation
cons = 0;   % transformation constant

states_trans1 = [(F * state_vect1(size(state_vect1,1),1:5)')' (F * state_vect1(size(state_vect1,1),6:10)')'];

toc;
%% Phase 2
tic;
theta_b = 2.3876;
theta_e = q2_e(1);

    
Coeff = [0         0         0;
   -1.3801   -1.3801   -1.5500;
   -0.8088   -0.8088   -0.5500;
   -0.8032   -0.8032   -0.7500;
   -1.4581   -1.4581   -1.6100];

y_e = 0;
x_e = 0;

x0_red_dyn = [states_trans1(1) states_trans1(6)]; % pos, vel
theta_0 = x0_red_dyn(1);
dtheta_0 = x0_red_dyn(2);
integral_initial_value = integral_values(size(integral_values,1));

run motors_initial_values_phase2

sim('MASTER_sim_transys_phase2_test_const_K2',tspan, options, []);

state_vect2 = [x_red(:,1) phi2_5_res(:,1) phi2_5_res(:,2) phi2_5_res(:,3) phi2_5_res(:,4) x_red(:,2) Dphi2_5_res(:,1) Dphi2_5_res(:,2) Dphi2_5_res(:,3) Dphi2_5_res(:,4)];
state_vect = [state_vect;state_vect2];
phi_reference_values = [phi_reference_values;phi2_5_reference];
Dphi_reference_values = [Dphi_reference_values;Dphi2_5_reference];
integral_values = [integral_values;integral_value];
u_signal = [u_signal;u_sig];
transverse_coordinates = [transverse_coordinates;trans_coordinates];
time = [time;t_red+time(size(time,1))];
% ddtheta_sim_t = [ddtheta_sim_t;ddtheta_sim];

time_constant = time(size(time,1));

% Phase transition 2
F = [1 1 1 1 1;         % nontrivial angle transformation
    0 0 0 0 -1;
    0 0 0 -1 0;
    0 0 -1 0 0;
    0 -1 0 0 0];

cons = [pi 0 0 0 0]';   % angle transformation constant

[H1, H2] = impact_velocities(state_vect2(size(state_vect2,1), 1), state_vect2(size(state_vect2,1), 2), state_vect2(size(state_vect2,1), 3), state_vect2(size(state_vect2,1), 4), state_vect2(size(state_vect2,1), 5));

vel_after_impact_i =(H1 \ H2 ) * state_vect2(size(state_vect2,1), 6:10)';
vel_after_impact = [sum(vel_after_impact_i) -vel_after_impact_i(5) -vel_after_impact_i(4) -vel_after_impact_i(3) -vel_after_impact_i(2)];

states_trans2 = [(F * state_vect2(size(state_vect2,1), 1:5)' + cons)' vel_after_impact];
toc;

%% Phase 3
theta_b = 0.7816;%states_trans2(1);%
theta_e = 0;
tic;

Coeff = [0         0         0;
    1.6100    1.8851    1.6801;
    0.7500    0.6567    0.5104;
    0.5500    0.4123    0.5000;
    1.5500    3.5925    0.3008];
  
foot_pos = calculatePoints(state_vect2(size(state_vect2,1),1:5), 0, 0);
y_e = foot_pos(6, 2);
x_e = foot_pos(6, 1);

x0_red_dyn = [states_trans2(1) states_trans2(6)]; % pos, vel
theta_0 = x0_red_dyn(1);
dtheta_0 = x0_red_dyn(2);
integral_initial_value = integral_values(size(integral_values,1));

run motors_initial_values_phase3

sim('MASTER_sim_transys_phase3_test_const_K2',tspan, options, []);

state_vect3 = [x_red(:,1) phi2_5_res(:,1) phi2_5_res(:,2) phi2_5_res(:,3) phi2_5_res(:,4) x_red(:,2) Dphi2_5_res(:,1) Dphi2_5_res(:,2) Dphi2_5_res(:,3) Dphi2_5_res(:,4)];
state_vect = [state_vect; state_vect3];
phi_reference_values = [phi_reference_values;phi2_5_reference];
Dphi_reference_values = [Dphi_reference_values;Dphi2_5_reference];
integral_values = [integral_values;integral_value];
u_signal = [u_signal;u_sig];
transverse_coordinates = [transverse_coordinates;trans_coordinates];
time = [time;t_red+time(size(time,1))];

time_constant = time(size(time,1));

F = eye(5); % trivial transformation
cons = 0;   % transformation constant

states_trans3 = [(F * state_vect3(size(state_vect3,1),1:5)')'    (F * state_vect3(size(state_vect3,1),6:10)')']; % in the moment of transition
toc;
%% Phase 4
tic;
q4_e = cal_endconfig4( q1 );

theta_b = 0.2434;%states_trans3(1);%
theta_e = q4_e(1);

Coeff = [ 0         0         0;
    1.7612    1.7612    1.3000;
    0.5964    0.5964    0.9000;
    0.4672    0.4672    0.9000;
    1.8338    1.8338    1.3000];

x0_red_dyn = [states_trans3(1) states_trans3(6)]; % pos, vel
theta_0 = x0_red_dyn(1);
dtheta_0 = x0_red_dyn(2);
integral_initial_value = integral_values(size(integral_values,1));

run motors_initial_values_phase4

sim('MASTER_sim_transys_phase4_test_const_K2',tspan, options, []);

state_vect4 = [x_red(:,1) phi2_5_res(:,1) phi2_5_res(:,2) phi2_5_res(:,3) phi2_5_res(:,4) x_red(:,2) Dphi2_5_res(:,1) Dphi2_5_res(:,2) Dphi2_5_res(:,3) Dphi2_5_res(:,4)];
state_vect = [state_vect; state_vect4];
phi_reference_values = [phi_reference_values;phi2_5_reference];
Dphi_reference_values = [Dphi_reference_values;Dphi2_5_reference];
integral_values = [integral_values;integral_value];
u_signal = [u_signal;u_sig];
transverse_coordinates = [transverse_coordinates;trans_coordinates];
time = [time;t_red+time(size(time,1))];

time_constant = time(size(time,1));

% Phase transition 4
F = [1 1 1 1 1;         % nontrivial angle transformation
    0 0 0 0 -1;
    0 0 0 -1 0;
    0 0 -1 0 0;
    0 -1 0 0 0];

cons = [-pi 0 0 0 0]';   % angle transformation constant

[H1, H2] = impact_velocities(state_vect4(size(state_vect4,1), 1), state_vect4(size(state_vect4,1), 2), state_vect4(size(state_vect4,1), 3), state_vect4(size(state_vect4,1), 4), state_vect4(size(state_vect4,1), 5));

vel_after_impact_i = (H1 \ H2 ) * state_vect4(size(state_vect4,1), 6:10)';
vel_after_impact = [sum(vel_after_impact_i) -vel_after_impact_i(5) -vel_after_impact_i(4) -vel_after_impact_i(3) -vel_after_impact_i(2)];

states_trans4 = [(F * state_vect4(size(state_vect4,1), 1:5)' + cons)' vel_after_impact];
toc;

%% Plot
run plot_phaseplot


