function [ phis ] = fct_calc_phi_refs( theta )
%FCT_CALC_PHI_REFS Calculates the reference values for links 2-5
%   Detailed explanation goes here

global theta_e theta_b
global Coeff

theta_diff = theta_e - theta_b;
theta_progress = theta - theta_b;
theta_01 = theta_progress/theta_diff;

phi_ref_2 = outputPointOnBezier( Coeff(2,1), Coeff(2,2), Coeff(2,3), theta_01 );
phi_ref_3 = outputPointOnBezier( Coeff(3,1), Coeff(3,2), Coeff(3,3), theta_01 );
phi_ref_4 = outputPointOnBezier( Coeff(4,1), Coeff(4,2), Coeff(4,3), theta_01 );
phi_ref_5 = outputPointOnBezier( Coeff(5,1), Coeff(5,2), Coeff(5,3), theta_01 );

phis = [phi_ref_2 phi_ref_3 phi_ref_4 phi_ref_5];

end

