function [ u ] = fct_feedback_transform( q, Dq, v )
%FCT_FEEDBACK_TRANSFORM Summary of this function goes here
%   Detailed explanation goes here

theta = q(1);
dtheta = Dq(1);
Dqs = [Dq(1);Dq(2);Dq(3);Dq(4);Dq(5);];
vs = [v(1);v(2);v(3);v(4);];

%%
y_dots = [Dqs(2) - dphi(theta, 2) * dtheta;
          Dqs(3) - dphi(theta, 3) * dtheta;
          Dqs(4) - dphi(theta, 4) * dtheta;
          Dqs(5) - dphi(theta, 5) * dtheta;];
        
L_matr = [eye(4) zeros(4,1);
            zeros(1,5)]+ [zeros(1,4) dphi(theta, 2); 
                            zeros(1,4) dphi(theta, 3); 
                            zeros(1,4) dphi(theta, 4); 
                            zeros(1,4) dphi(theta, 5); 
                            zeros(1,4) 1];
DL_matr = [zeros(1,4) ddphi(theta, 2)*dtheta; 
           zeros(1,4) ddphi(theta, 3)*dtheta; 
           zeros(1,4) ddphi(theta, 4)*dtheta; 
           zeros(1,4) ddphi(theta, 5)*dtheta; 
           zeros(1,4) 0];
       
invL = inv(L_matr);
[M, C, G] = fct_MCG_matrices(q, Dq);
invM = inv(M);
B = [zeros(1,4); eye(4)];

N_matr = [eye(4) zeros(4,1)] * invL * (invM * B);
R_matr = [eye(4) zeros(4,1)] * invL * (invM * (- C * Dqs - G) - DL_matr * [y_dots;dtheta]);

u = inv(N_matr) *(vs - R_matr);

end

