figure(1)
grid on
hold on
set(gca,'FontSize',18)
xlabel('\theta')
ylabel('$\dot{\theta}$','interpreter','latex')
set(gca,'FontSize',18)
plot(state_vect1(1,1),state_vect1(1,6),'rs', 'MarkerSize',15)
plot(state_vect1(:,1),state_vect1(:,6))
plot(state_vect2(:,1),state_vect2(:,6))
plot(state_vect2(size(state_vect2,1),1),state_vect2(size(state_vect2,1),6),'ro', 'MarkerSize',15)
plot([state_vect2(size(state_vect2,1),1) state_vect3(1,1)],[state_vect2(size(state_vect2,1),6) state_vect3(1,6)],'r-.')
plot(state_vect3(1,1),state_vect3(1,6),'ro', 'MarkerSize',15)
plot(state_vect3(:,1),state_vect3(:,6))
plot(state_vect4(:,1),state_vect4(:,6))
plot(state_vect4(size(state_vect4,1),1),state_vect4(size(state_vect4,1),6),'ro', 'MarkerSize',15)
plot([state_vect4(size(state_vect4,1),1) states_trans4(1)],[state_vect4(size(state_vect4,1),6) states_trans4(6)],'r-.')
plot(states_trans4(1),states_trans4(6), 'rd', 'MarkerSize',15)

load optimal_phase_plot_455cm.mat
plot(optimal_phase_plot(:,1),optimal_phase_plot(:,2),'r')



%% Plot phis against their reference
figure(5)
subplot(2,2,1)
hold on
grid on
title('Phi2', 'FontSize', 18)
set(gca,'FontSize',18)
plot(time,state_vect(:,2))
plot(time,phi_reference_values(:,1),'r')

subplot(2,2,2)
hold on
grid on
title('Phi3', 'FontSize', 18)
set(gca,'FontSize',18)
plot(time,state_vect(:,3))
plot(time,phi_reference_values(:,2),'r')

subplot(2,2,3)
hold on
grid on
title('Phi4', 'FontSize', 18)
set(gca,'FontSize',18)
plot(time,state_vect(:,4))
plot(time,phi_reference_values(:,3),'r')

subplot(2,2,4)
hold on
grid on
title('Phi5', 'FontSize', 18)
set(gca,'FontSize',18)
plot(time,state_vect(:,5))
plot(time,phi_reference_values(:,4),'r')

%% Plot Dphis against their reference
figure(6)
subplot(2,2,1)
hold on
grid on
title('DPhi2', 'FontSize', 18)
set(gca,'FontSize',18)
plot(time,state_vect(:,7))
plot(time,Dphi_reference_values(:,1),'r')

subplot(2,2,2)
hold on
grid on
title('DPhi3', 'FontSize', 18)
set(gca,'FontSize',18)
plot(time,state_vect(:,8))
plot(time,Dphi_reference_values(:,2),'r')

subplot(2,2,3)
hold on
grid on
title('DPhi4', 'FontSize', 18)
set(gca,'FontSize',18)
plot(time,state_vect(:,9))
plot(time,Dphi_reference_values(:,3),'r')

subplot(2,2,4)
hold on
grid on
title('DPhi5', 'FontSize', 18)
set(gca,'FontSize',18)
plot(time,state_vect(:,10))
plot(time,Dphi_reference_values(:,4),'r')

%% %%%%%%%%%%
% figure(7)
% set(gca,'FontSize',18)
% plot(time,integral_values(:))
% grid on
% title('Integral', 'FontSize', 18)


%% %%%%%%%%%
% figure(8)
% title('Actuation Signal')
% subplot(2,2,1)
% hold on
% grid on
% title('U2')
% plot(time,u_signal(:,1))
% 
% subplot(2,2,2)
% hold on
% grid on
% title('U3')
% plot(time,u_signal(:,2))
% 
% subplot(2,2,3)
% hold on
% grid on
% title('U4')
% plot(time,u_signal(:,3))
% 
% subplot(2,2,4)
% hold on
% grid on
% title('U5')
% plot(time,u_signal(:,4))

%% %%%%%%%%%
% figure(9)
% title('Transverse Coordinates')
% subplot(3,3,1)
% hold on
% grid on
% title('Integral')
% plot(time,transverse_coordinates(:,1))
% 
% subplot(3,3,2)
% hold on
% grid on
% title('Y1')
% plot(time,transverse_coordinates(:,2))
% 
% subplot(3,3,3)
% hold on
% grid on
% title('Y2')
% plot(time,transverse_coordinates(:,3))
% 
% subplot(3,3,4)
% hold on
% grid on
% title('Y3')
% plot(time,transverse_coordinates(:,4))
% 
% subplot(3,3,5)
% hold on
% grid on
% title('Y4')
% plot(time,transverse_coordinates(:,5))
% 
% subplot(3,3,6)
% hold on
% grid on
% title('Ydot1')
% plot(time,transverse_coordinates(:,6))
% 
% subplot(3,3,7)
% hold on
% grid on
% title('Ydot2')
% plot(time,transverse_coordinates(:,7))
% 
% subplot(3,3,8)
% hold on
% grid on
% title('Ydot3')
% plot(time,transverse_coordinates(:,8))
% 
% subplot(3,3,9)
% hold on
% grid on
% title('Ydot4')
% plot(time,transverse_coordinates(:,9))



