function [ out ] = MASTER_fct_contact_forces( thetas )
%MASTER_FCT_CONTACT_FORCES Summary of this function goes here
%   Detailed explanation goes here

% Declare global parameters
global l s
global m1 m2 m3 m4 m5 I1 I2 I3 I4 I5 g

q1 = thetas(1);
q2 = phi(thetas(1),2);
q3 = phi(thetas(1),3);
q4 = phi(thetas(1),4);
q5 = phi(thetas(1),5);

Dq1 = thetas(2);
Dq2 = dphi(thetas(1),2).*thetas(2);
Dq3 = dphi(thetas(1),3).*thetas(2);
Dq4 = dphi(thetas(1),4).*thetas(2);
Dq5 = dphi(thetas(1),5).*thetas(2);

DDq1 = thetas(3);
DDq2 = ddphi(thetas(1),2).*thetas(2)^2+dphi(thetas(1),2).*thetas(3);
DDq3 = ddphi(thetas(1),3).*thetas(2)^2+dphi(thetas(1),3).*thetas(3);
DDq4 = ddphi(thetas(1),4).*thetas(2)^2+dphi(thetas(1),4).*thetas(3);
DDq5 = ddphi(thetas(1),5).*thetas(2)^2+dphi(thetas(1),5).*thetas(3);


DDq = [DDq1 DDq2 DDq3 DDq4 DDq5 0 0]';
Dq = [Dq1 Dq2 Dq3 Dq4 Dq5 0 0]';
q = [q1 q2 q3 q4 q5 0 0]';


Mext = [m5 * l(4) ^ 2 + I2 + I1 + I3 + I4 + I5 + m1 * l(1) ^ 2 + m5 * l(3) ^ 2 + m4 * s(4) ^ 2 + m3 * l(3) ^ 2 + m2 * l(1) ^ 2 + m3 * s(3) ^ 2 + m5 * s(5) ^ 2 + m1 * s(1) ^ 2 + m5 * l(2) ^ 2 + m4 * l(3) ^ 2 + m3 * l(2) ^ 2 + m3 * l(1) ^ 2 + m2 * l(2) ^ 2 + m4 * l(2) ^ 2 + m2 * s(2) ^ 2 + m5 * l(1) ^ 2 + m4 * l(1) ^ 2 + 0.2e1 * m5 * l(1) * s(5) * cos(q2 + q3 + q4 + q5) + 0.2e1 * m5 * l(2) * s(5) * cos(q3 + q4 + q5) + 0.2e1 * m5 * l(3) * s(5) * cos(q4 + q5) + 0.2e1 * m5 * l(4) * s(5) * cos(q5) + 0.2e1 * m4 * l(2) * s(4) * cos(q3 + q4) + 0.2e1 * m4 * l(3) * s(4) * cos(q4) + 0.2e1 * m5 * l(1) * l(4) * cos(q2 + q3 + q4) + 0.2e1 * m5 * l(2) * l(4) * cos(q3 + q4) + 0.2e1 * m5 * l(3) * l(4) * cos(q4) + 0.2e1 * m4 * l(1) * s(4) * cos(q2 + q3 + q4) + 0.2e1 * m4 * l(1) * l(3) * cos(q2 + q3) + 0.2e1 * m5 * l(1) * l(3) * cos(q2 + q3) + 0.2e1 * m5 * l(2) * l(3) * cos(q3) + 0.2e1 * m4 * l(2) * l(3) * cos(q3) + 0.2e1 * m3 * l(1) * l(3) * cos(q2 + q3) - 0.2e1 * m3 * l(1) * s(3) * cos(q2 + q3) + 0.2e1 * m3 * l(2) * l(3) * cos(q3) - 0.2e1 * m3 * l(2) * s(3) * cos(q3) + 0.2e1 * m2 * l(1) * l(2) * cos(q2) - 0.2e1 * m2 * l(1) * s(2) * cos(q2) + 0.2e1 * m3 * l(1) * l(2) * cos(q2) + 0.2e1 * m5 * l(1) * l(2) * cos(q2) + 0.2e1 * m4 * l(1) * l(2) * cos(q2) - 0.2e1 * m3 * l(3) * s(3) - 0.2e1 * m2 * l(2) * s(2) - 0.2e1 * m1 * l(1) * s(1) m5 * l(4) ^ 2 + I2 + I3 + I4 + I5 + m5 * l(3) ^ 2 + m4 * s(4) ^ 2 + m3 * l(3) ^ 2 + m3 * s(3) ^ 2 + m5 * s(5) ^ 2 + m5 * l(2) ^ 2 + m4 * l(3) ^ 2 + m3 * l(2) ^ 2 + m2 * l(2) ^ 2 + m4 * l(2) ^ 2 + m2 * s(2) ^ 2 + m5 * l(1) * s(5) * cos(q2 + q3 + q4 + q5) + 0.2e1 * m5 * l(2) * s(5) * cos(q3 + q4 + q5) + 0.2e1 * m5 * l(3) * s(5) * cos(q4 + q5) + 0.2e1 * m5 * l(4) * s(5) * cos(q5) + 0.2e1 * m4 * l(2) * s(4) * cos(q3 + q4) + 0.2e1 * m4 * l(3) * s(4) * cos(q4) + m5 * l(1) * l(4) * cos(q2 + q3 + q4) + 0.2e1 * m5 * l(2) * l(4) * cos(q3 + q4) + 0.2e1 * m5 * l(3) * l(4) * cos(q4) + m4 * l(1) * s(4) * cos(q2 + q3 + q4) + m4 * l(1) * l(3) * cos(q2 + q3) + m5 * l(1) * l(3) * cos(q2 + q3) + 0.2e1 * m5 * l(2) * l(3) * cos(q3) + 0.2e1 * m4 * l(2) * l(3) * cos(q3) + m3 * l(1) * l(3) * cos(q2 + q3) - m3 * l(1) * s(3) * cos(q2 + q3) + 0.2e1 * m3 * l(2) * l(3) * cos(q3) - 0.2e1 * m3 * l(2) * s(3) * cos(q3) + m2 * l(1) * l(2) * cos(q2) - m2 * l(1) * s(2) * cos(q2) + m3 * l(1) * l(2) * cos(q2) + m5 * l(1) * l(2) * cos(q2) + m4 * l(1) * l(2) * cos(q2) - 0.2e1 * m3 * l(3) * s(3) - 0.2e1 * m2 * l(2) * s(2) m5 * l(4) ^ 2 + I3 + I4 + I5 + m5 * l(3) ^ 2 + m4 * s(4) ^ 2 + m3 * l(3) ^ 2 + m3 * s(3) ^ 2 + m5 * s(5) ^ 2 + m4 * l(3) ^ 2 + m5 * l(1) * s(5) * cos(q2 + q3 + q4 + q5) + m5 * l(2) * s(5) * cos(q3 + q4 + q5) + 0.2e1 * m5 * l(3) * s(5) * cos(q4 + q5) + 0.2e1 * m5 * l(4) * s(5) * cos(q5) + m4 * l(2) * s(4) * cos(q3 + q4) + 0.2e1 * m4 * l(3) * s(4) * cos(q4) + m5 * l(1) * l(4) * cos(q2 + q3 + q4) + m5 * l(2) * l(4) * cos(q3 + q4) + 0.2e1 * m5 * l(3) * l(4) * cos(q4) + m4 * l(1) * s(4) * cos(q2 + q3 + q4) + m4 * l(1) * l(3) * cos(q2 + q3) + m5 * l(1) * l(3) * cos(q2 + q3) + m5 * l(2) * l(3) * cos(q3) + m4 * l(2) * l(3) * cos(q3) + m3 * l(1) * l(3) * cos(q2 + q3) - m3 * l(1) * s(3) * cos(q2 + q3) + m3 * l(2) * l(3) * cos(q3) - m3 * l(2) * s(3) * cos(q3) - 0.2e1 * m3 * l(3) * s(3) m5 * l(4) ^ 2 + m5 * s(5) ^ 2 + m4 * s(4) ^ 2 + I4 + I5 + m4 * l(2) * s(4) * cos(q3 + q4) + m4 * l(3) * s(4) * cos(q4) + m5 * l(1) * l(4) * cos(q2 + q3 + q4) + m5 * l(1) * s(5) * cos(q2 + q3 + q4 + q5) + m5 * l(2) * l(4) * cos(q3 + q4) + m5 * l(2) * s(5) * cos(q3 + q4 + q5) + m5 * l(3) * l(4) * cos(q4) + m5 * l(3) * s(5) * cos(q4 + q5) + 0.2e1 * m5 * l(4) * s(5) * cos(q5) + m4 * l(1) * s(4) * cos(q2 + q3 + q4) m5 * s(5) ^ 2 + I5 + m5 * l(1) * s(5) * cos(q2 + q3 + q4 + q5) + m5 * l(2) * s(5) * cos(q3 + q4 + q5) + m5 * l(3) * s(5) * cos(q4 + q5) + m5 * l(4) * s(5) * cos(q5) -m4 * sin(q1) * l(1) - m4 * sin(q1 + q2) * l(2) - m4 * sin(q1 + q2 + q3) * l(3) - m5 * l(4) * sin(q1 + q2 + q3 + q4) - m5 * sin(q1 + q2 + q3) * l(3) - m5 * sin(q1 + q2) * l(2) - m5 * sin(q1) * l(1) - m4 * s(4) * sin(q1 + q2 + q3 + q4) - m2 * sin(q1 + q2) * l(2) - m3 * sin(q1 + q2 + q3) * l(3) + m3 * sin(q1 + q2 + q3) * s(3) + m2 * sin(q1 + q2) * s(2) - m1 * sin(q1) * l(1) - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) - m3 * sin(q1 + q2) * l(2) + m1 * sin(q1) * s(1) - m3 * sin(q1) * l(1) - m2 * sin(q1) * l(1) m1 * cos(q1) * l(1) - m1 * cos(q1) * s(1) + m2 * cos(q1) * l(1) + m2 * cos(q1 + q2) * l(2) - m2 * cos(q1 + q2) * s(2) + m3 * cos(q1) * l(1) + m3 * cos(q1 + q2) * l(2) + m3 * cos(q1 + q2 + q3) * l(3) - m3 * cos(q1 + q2 + q3) * s(3) + m4 * cos(q1) * l(1) + m4 * cos(q1 + q2) * l(2) + m4 * cos(q1 + q2 + q3) * l(3) + m4 * s(4) * cos(q1 + q2 + q3 + q4) + m5 * cos(q1) * l(1) + m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) + m5 * cos(q1 + q2) * l(2) + m5 * cos(q1 + q2 + q3) * l(3) + m5 * l(4) * cos(q1 + q2 + q3 + q4); m5 * l(4) ^ 2 + I2 + I3 + I4 + I5 + m5 * l(3) ^ 2 + m4 * s(4) ^ 2 + m3 * l(3) ^ 2 + m3 * s(3) ^ 2 + m5 * s(5) ^ 2 + m5 * l(2) ^ 2 + m4 * l(3) ^ 2 + m3 * l(2) ^ 2 + m2 * l(2) ^ 2 + m4 * l(2) ^ 2 + m2 * s(2) ^ 2 + m5 * l(1) * s(5) * cos(q2 + q3 + q4 + q5) + 0.2e1 * m5 * l(2) * s(5) * cos(q3 + q4 + q5) + 0.2e1 * m5 * l(3) * s(5) * cos(q4 + q5) + 0.2e1 * m5 * l(4) * s(5) * cos(q5) + 0.2e1 * m4 * l(2) * s(4) * cos(q3 + q4) + 0.2e1 * m4 * l(3) * s(4) * cos(q4) + m5 * l(1) * l(4) * cos(q2 + q3 + q4) + 0.2e1 * m5 * l(2) * l(4) * cos(q3 + q4) + 0.2e1 * m5 * l(3) * l(4) * cos(q4) + m4 * l(1) * s(4) * cos(q2 + q3 + q4) + m4 * l(1) * l(3) * cos(q2 + q3) + m5 * l(1) * l(3) * cos(q2 + q3) + 0.2e1 * m5 * l(2) * l(3) * cos(q3) + 0.2e1 * m4 * l(2) * l(3) * cos(q3) + m3 * l(1) * l(3) * cos(q2 + q3) - m3 * l(1) * s(3) * cos(q2 + q3) + 0.2e1 * m3 * l(2) * l(3) * cos(q3) - 0.2e1 * m3 * l(2) * s(3) * cos(q3) + m2 * l(1) * l(2) * cos(q2) - m2 * l(1) * s(2) * cos(q2) + m3 * l(1) * l(2) * cos(q2) + m5 * l(1) * l(2) * cos(q2) + m4 * l(1) * l(2) * cos(q2) - 0.2e1 * m3 * l(3) * s(3) - 0.2e1 * m2 * l(2) * s(2) m5 * l(4) ^ 2 + I2 + I3 + I4 + I5 + m5 * l(3) ^ 2 + m4 * s(4) ^ 2 + m3 * l(3) ^ 2 + m3 * s(3) ^ 2 + m5 * s(5) ^ 2 + m5 * l(2) ^ 2 + m4 * l(3) ^ 2 + m3 * l(2) ^ 2 + m2 * l(2) ^ 2 + m4 * l(2) ^ 2 + m2 * s(2) ^ 2 + 0.2e1 * m5 * l(2) * s(5) * cos(q3 + q4 + q5) + 0.2e1 * m5 * l(3) * s(5) * cos(q4 + q5) + 0.2e1 * m5 * l(4) * s(5) * cos(q5) + 0.2e1 * m4 * l(2) * s(4) * cos(q3 + q4) + 0.2e1 * m4 * l(3) * s(4) * cos(q4) + 0.2e1 * m5 * l(2) * l(4) * cos(q3 + q4) + 0.2e1 * m5 * l(3) * l(4) * cos(q4) + 0.2e1 * m5 * l(2) * l(3) * cos(q3) + 0.2e1 * m4 * l(2) * l(3) * cos(q3) + 0.2e1 * m3 * l(2) * l(3) * cos(q3) - 0.2e1 * m3 * l(2) * s(3) * cos(q3) - 0.2e1 * m3 * l(3) * s(3) - 0.2e1 * m2 * l(2) * s(2) -0.2e1 * m3 * l(3) * s(3) + m5 * l(4) ^ 2 + m3 * s(3) ^ 2 + m5 * s(5) ^ 2 + m3 * l(3) ^ 2 + m4 * l(3) ^ 2 + m5 * l(3) ^ 2 + m4 * s(4) ^ 2 + I4 + I3 + I5 + m4 * l(2) * s(4) * cos(q3 + q4) + m5 * l(2) * l(4) * cos(q3 + q4) + m5 * l(2) * s(5) * cos(q3 + q4 + q5) + m3 * l(2) * l(3) * cos(q3) - m3 * l(2) * s(3) * cos(q3) + 0.2e1 * m5 * l(3) * l(4) * cos(q4) + 0.2e1 * m5 * l(4) * s(5) * cos(q5) + 0.2e1 * m4 * l(3) * s(4) * cos(q4) + m5 * l(2) * l(3) * cos(q3) + 0.2e1 * m5 * l(3) * s(5) * cos(q4 + q5) + m4 * l(2) * l(3) * cos(q3) m5 * l(4) ^ 2 + m5 * s(5) ^ 2 + m4 * s(4) ^ 2 + I4 + I5 + m4 * l(2) * s(4) * cos(q3 + q4) + m5 * l(2) * l(4) * cos(q3 + q4) + m5 * l(2) * s(5) * cos(q3 + q4 + q5) + m5 * l(3) * l(4) * cos(q4) + 0.2e1 * m5 * l(4) * s(5) * cos(q5) + m4 * l(3) * s(4) * cos(q4) + m5 * l(3) * s(5) * cos(q4 + q5) m5 * s(5) ^ 2 + I5 + m5 * l(2) * s(5) * cos(q3 + q4 + q5) + m5 * l(4) * s(5) * cos(q5) + m5 * l(3) * s(5) * cos(q4 + q5) -m4 * sin(q1 + q2) * l(2) - m4 * sin(q1 + q2 + q3) * l(3) - m5 * l(4) * sin(q1 + q2 + q3 + q4) - m5 * sin(q1 + q2 + q3) * l(3) - m5 * sin(q1 + q2) * l(2) - m4 * s(4) * sin(q1 + q2 + q3 + q4) + m3 * sin(q1 + q2 + q3) * s(3) - m3 * sin(q1 + q2 + q3) * l(3) + m2 * sin(q1 + q2) * s(2) - m2 * sin(q1 + q2) * l(2) - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) - m3 * sin(q1 + q2) * l(2) m2 * cos(q1 + q2) * l(2) - m2 * cos(q1 + q2) * s(2) + m3 * cos(q1 + q2) * l(2) + m3 * cos(q1 + q2 + q3) * l(3) - m3 * cos(q1 + q2 + q3) * s(3) + m4 * cos(q1 + q2) * l(2) + m4 * cos(q1 + q2 + q3) * l(3) + m4 * s(4) * cos(q1 + q2 + q3 + q4) + m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) + m5 * cos(q1 + q2) * l(2) + m5 * cos(q1 + q2 + q3) * l(3) + m5 * l(4) * cos(q1 + q2 + q3 + q4); m5 * l(4) ^ 2 + I3 + I4 + I5 + m5 * l(3) ^ 2 + m4 * s(4) ^ 2 + m3 * l(3) ^ 2 + m3 * s(3) ^ 2 + m5 * s(5) ^ 2 + m4 * l(3) ^ 2 + m5 * l(1) * s(5) * cos(q2 + q3 + q4 + q5) + m5 * l(2) * s(5) * cos(q3 + q4 + q5) + 0.2e1 * m5 * l(3) * s(5) * cos(q4 + q5) + 0.2e1 * m5 * l(4) * s(5) * cos(q5) + m4 * l(2) * s(4) * cos(q3 + q4) + 0.2e1 * m4 * l(3) * s(4) * cos(q4) + m5 * l(1) * l(4) * cos(q2 + q3 + q4) + m5 * l(2) * l(4) * cos(q3 + q4) + 0.2e1 * m5 * l(3) * l(4) * cos(q4) + m4 * l(1) * s(4) * cos(q2 + q3 + q4) + m4 * l(1) * l(3) * cos(q2 + q3) + m5 * l(1) * l(3) * cos(q2 + q3) + m5 * l(2) * l(3) * cos(q3) + m4 * l(2) * l(3) * cos(q3) + m3 * l(1) * l(3) * cos(q2 + q3) - m3 * l(1) * s(3) * cos(q2 + q3) + m3 * l(2) * l(3) * cos(q3) - m3 * l(2) * s(3) * cos(q3) - 0.2e1 * m3 * l(3) * s(3) -0.2e1 * m3 * l(3) * s(3) + m5 * l(4) ^ 2 + m3 * s(3) ^ 2 + m5 * s(5) ^ 2 + m3 * l(3) ^ 2 + m4 * l(3) ^ 2 + m5 * l(3) ^ 2 + m4 * s(4) ^ 2 + I4 + I3 + I5 + m4 * l(2) * s(4) * cos(q3 + q4) + m5 * l(2) * l(4) * cos(q3 + q4) + m5 * l(2) * s(5) * cos(q3 + q4 + q5) + m3 * l(2) * l(3) * cos(q3) - m3 * l(2) * s(3) * cos(q3) + 0.2e1 * m5 * l(3) * l(4) * cos(q4) + 0.2e1 * m5 * l(4) * s(5) * cos(q5) + 0.2e1 * m4 * l(3) * s(4) * cos(q4) + m5 * l(2) * l(3) * cos(q3) + 0.2e1 * m5 * l(3) * s(5) * cos(q4 + q5) + m4 * l(2) * l(3) * cos(q3) -0.2e1 * m3 * l(3) * s(3) + m5 * s(5) ^ 2 + m5 * l(3) ^ 2 + m5 * l(4) ^ 2 + m3 * l(3) ^ 2 + m4 * l(3) ^ 2 + m3 * s(3) ^ 2 + m4 * s(4) ^ 2 + I5 + I3 + I4 + 0.2e1 * m5 * l(4) * s(5) * cos(q5) + 0.2e1 * m5 * l(3) * s(5) * cos(q4 + q5) + 0.2e1 * m4 * l(3) * s(4) * cos(q4) + 0.2e1 * m5 * l(3) * l(4) * cos(q4) m5 * s(5) ^ 2 + m5 * l(4) ^ 2 + m4 * s(4) ^ 2 + I5 + I4 + 0.2e1 * m5 * l(4) * s(5) * cos(q5) + m5 * l(3) * s(5) * cos(q4 + q5) + m4 * l(3) * s(4) * cos(q4) + m5 * l(3) * l(4) * cos(q4) m5 * s(5) ^ 2 + I5 + m5 * l(4) * s(5) * cos(q5) + m5 * l(3) * s(5) * cos(q4 + q5) m3 * sin(q1 + q2 + q3) * s(3) - m4 * sin(q1 + q2 + q3) * l(3) - m5 * l(4) * sin(q1 + q2 + q3 + q4) - m5 * sin(q1 + q2 + q3) * l(3) - m4 * s(4) * sin(q1 + q2 + q3 + q4) - m3 * sin(q1 + q2 + q3) * l(3) - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) m3 * cos(q1 + q2 + q3) * l(3) - m3 * cos(q1 + q2 + q3) * s(3) + m4 * cos(q1 + q2 + q3) * l(3) + m4 * s(4) * cos(q1 + q2 + q3 + q4) + m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) + m5 * cos(q1 + q2 + q3) * l(3) + m5 * l(4) * cos(q1 + q2 + q3 + q4); m5 * l(4) ^ 2 + m5 * s(5) ^ 2 + m4 * s(4) ^ 2 + I4 + I5 + m4 * l(2) * s(4) * cos(q3 + q4) + m4 * l(3) * s(4) * cos(q4) + m5 * l(1) * l(4) * cos(q2 + q3 + q4) + m5 * l(1) * s(5) * cos(q2 + q3 + q4 + q5) + m5 * l(2) * l(4) * cos(q3 + q4) + m5 * l(2) * s(5) * cos(q3 + q4 + q5) + m5 * l(3) * l(4) * cos(q4) + m5 * l(3) * s(5) * cos(q4 + q5) + 0.2e1 * m5 * l(4) * s(5) * cos(q5) + m4 * l(1) * s(4) * cos(q2 + q3 + q4) m5 * l(4) ^ 2 + m5 * s(5) ^ 2 + m4 * s(4) ^ 2 + I4 + I5 + m4 * l(2) * s(4) * cos(q3 + q4) + m5 * l(2) * l(4) * cos(q3 + q4) + m5 * l(2) * s(5) * cos(q3 + q4 + q5) + m5 * l(3) * l(4) * cos(q4) + 0.2e1 * m5 * l(4) * s(5) * cos(q5) + m4 * l(3) * s(4) * cos(q4) + m5 * l(3) * s(5) * cos(q4 + q5) m5 * s(5) ^ 2 + m5 * l(4) ^ 2 + m4 * s(4) ^ 2 + I5 + I4 + 0.2e1 * m5 * l(4) * s(5) * cos(q5) + m5 * l(3) * s(5) * cos(q4 + q5) + m4 * l(3) * s(4) * cos(q4) + m5 * l(3) * l(4) * cos(q4) m5 * s(5) ^ 2 + m4 * s(4) ^ 2 + m5 * l(4) ^ 2 + I5 + I4 + 0.2e1 * m5 * l(4) * s(5) * cos(q5) m5 * s(5) ^ 2 + I5 + m5 * l(4) * s(5) * cos(q5) -m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) - m4 * s(4) * sin(q1 + q2 + q3 + q4) - m5 * l(4) * sin(q1 + q2 + q3 + q4) m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) + m4 * s(4) * cos(q1 + q2 + q3 + q4) + m5 * l(4) * cos(q1 + q2 + q3 + q4); m5 * s(5) ^ 2 + I5 + m5 * l(1) * s(5) * cos(q2 + q3 + q4 + q5) + m5 * l(2) * s(5) * cos(q3 + q4 + q5) + m5 * l(3) * s(5) * cos(q4 + q5) + m5 * l(4) * s(5) * cos(q5) m5 * s(5) ^ 2 + I5 + m5 * l(2) * s(5) * cos(q3 + q4 + q5) + m5 * l(4) * s(5) * cos(q5) + m5 * l(3) * s(5) * cos(q4 + q5) m5 * s(5) ^ 2 + I5 + m5 * l(4) * s(5) * cos(q5) + m5 * l(3) * s(5) * cos(q4 + q5) m5 * s(5) ^ 2 + I5 + m5 * l(4) * s(5) * cos(q5) m5 * s(5) ^ 2 + I5 -m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5); -m4 * sin(q1) * l(1) - m4 * sin(q1 + q2) * l(2) - m4 * sin(q1 + q2 + q3) * l(3) - m5 * l(4) * sin(q1 + q2 + q3 + q4) - m5 * sin(q1 + q2 + q3) * l(3) - m5 * sin(q1 + q2) * l(2) - m5 * sin(q1) * l(1) - m4 * s(4) * sin(q1 + q2 + q3 + q4) - m2 * sin(q1 + q2) * l(2) - m3 * sin(q1 + q2 + q3) * l(3) + m3 * sin(q1 + q2 + q3) * s(3) + m2 * sin(q1 + q2) * s(2) - m1 * sin(q1) * l(1) - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) - m3 * sin(q1 + q2) * l(2) + m1 * sin(q1) * s(1) - m3 * sin(q1) * l(1) - m2 * sin(q1) * l(1) -m4 * sin(q1 + q2) * l(2) - m4 * sin(q1 + q2 + q3) * l(3) - m5 * l(4) * sin(q1 + q2 + q3 + q4) - m5 * sin(q1 + q2 + q3) * l(3) - m5 * sin(q1 + q2) * l(2) - m4 * s(4) * sin(q1 + q2 + q3 + q4) + m3 * sin(q1 + q2 + q3) * s(3) - m3 * sin(q1 + q2 + q3) * l(3) + m2 * sin(q1 + q2) * s(2) - m2 * sin(q1 + q2) * l(2) - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) - m3 * sin(q1 + q2) * l(2) m3 * sin(q1 + q2 + q3) * s(3) - m4 * sin(q1 + q2 + q3) * l(3) - m5 * l(4) * sin(q1 + q2 + q3 + q4) - m5 * sin(q1 + q2 + q3) * l(3) - m4 * s(4) * sin(q1 + q2 + q3 + q4) - m3 * sin(q1 + q2 + q3) * l(3) - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) -m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) - m4 * s(4) * sin(q1 + q2 + q3 + q4) - m5 * l(4) * sin(q1 + q2 + q3 + q4) -m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) m5 + m1 + m2 + m3 + m4 0; m1 * cos(q1) * l(1) - m1 * cos(q1) * s(1) + m2 * cos(q1) * l(1) + m2 * cos(q1 + q2) * l(2) - m2 * cos(q1 + q2) * s(2) + m3 * cos(q1) * l(1) + m3 * cos(q1 + q2) * l(2) + m3 * cos(q1 + q2 + q3) * l(3) - m3 * cos(q1 + q2 + q3) * s(3) + m4 * cos(q1) * l(1) + m4 * cos(q1 + q2) * l(2) + m4 * cos(q1 + q2 + q3) * l(3) + m4 * s(4) * cos(q1 + q2 + q3 + q4) + m5 * cos(q1) * l(1) + m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) + m5 * cos(q1 + q2) * l(2) + m5 * cos(q1 + q2 + q3) * l(3) + m5 * l(4) * cos(q1 + q2 + q3 + q4) m2 * cos(q1 + q2) * l(2) - m2 * cos(q1 + q2) * s(2) + m3 * cos(q1 + q2) * l(2) + m3 * cos(q1 + q2 + q3) * l(3) - m3 * cos(q1 + q2 + q3) * s(3) + m4 * cos(q1 + q2) * l(2) + m4 * cos(q1 + q2 + q3) * l(3) + m4 * s(4) * cos(q1 + q2 + q3 + q4) + m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) + m5 * cos(q1 + q2) * l(2) + m5 * cos(q1 + q2 + q3) * l(3) + m5 * l(4) * cos(q1 + q2 + q3 + q4) m3 * cos(q1 + q2 + q3) * l(3) - m3 * cos(q1 + q2 + q3) * s(3) + m4 * cos(q1 + q2 + q3) * l(3) + m4 * s(4) * cos(q1 + q2 + q3 + q4) + m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) + m5 * cos(q1 + q2 + q3) * l(3) + m5 * l(4) * cos(q1 + q2 + q3 + q4) m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) + m4 * s(4) * cos(q1 + q2 + q3 + q4) + m5 * l(4) * cos(q1 + q2 + q3 + q4) m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) 0 m5 + m1 + m2 + m3 + m4;];
Gext = [m1 * g * cos(q1) * l(1) - m1 * g * cos(q1) * s(1) + m2 * g * cos(q1) * l(1) + m2 * g * cos(q1 + q2) * l(2) - m2 * g * cos(q1 + q2) * s(2) + m3 * g * cos(q1) * l(1) + m3 * g * cos(q1 + q2) * l(2) + m3 * g * cos(q1 + q2 + q3) * l(3) - m3 * g * cos(q1 + q2 + q3) * s(3) + m4 * g * cos(q1) * l(1) + m4 * g * cos(q1 + q2) * l(2) + m4 * g * cos(q1 + q2 + q3) * l(3) + m4 * g * s(4) * cos(q1 + q2 + q3 + q4) + m5 * g * cos(q1) * l(1) + m5 * g * cos(q1 + q2) * l(2) + m5 * g * cos(q1 + q2 + q3) * l(3) + m5 * g * l(4) * cos(q1 + q2 + q3 + q4) + m5 * g * s(5) * cos(q1 + q2 + q3 + q4 + q5) m2 * g * cos(q1 + q2) * l(2) - m2 * g * cos(q1 + q2) * s(2) + m3 * g * cos(q1 + q2) * l(2) + m3 * g * cos(q1 + q2 + q3) * l(3) - m3 * g * cos(q1 + q2 + q3) * s(3) + m4 * g * cos(q1 + q2) * l(2) + m4 * g * cos(q1 + q2 + q3) * l(3) + m4 * g * s(4) * cos(q1 + q2 + q3 + q4) + m5 * g * cos(q1 + q2) * l(2) + m5 * g * cos(q1 + q2 + q3) * l(3) + m5 * g * l(4) * cos(q1 + q2 + q3 + q4) + m5 * g * s(5) * cos(q1 + q2 + q3 + q4 + q5) m3 * g * cos(q1 + q2 + q3) * l(3) - m3 * g * cos(q1 + q2 + q3) * s(3) + m4 * g * cos(q1 + q2 + q3) * l(3) + m4 * g * s(4) * cos(q1 + q2 + q3 + q4) + m5 * g * cos(q1 + q2 + q3) * l(3) + m5 * g * l(4) * cos(q1 + q2 + q3 + q4) + m5 * g * s(5) * cos(q1 + q2 + q3 + q4 + q5) m4 * g * s(4) * cos(q1 + q2 + q3 + q4) + m5 * g * l(4) * cos(q1 + q2 + q3 + q4) + m5 * g * s(5) * cos(q1 + q2 + q3 + q4 + q5) m5 * g * s(5) * cos(q1 + q2 + q3 + q4 + q5) 0 m1 * g + m2 * g + m3 * g + m4 * g + m5 * g];
Cext = [-m5 * l(1) * s(5) * Dq3 * sin(q2 + q3 + q4 + q5) - m5 * l(1) * s(5) * Dq4 * sin(q2 + q3 + q4 + q5) - m5 * l(1) * s(5) * Dq5 * sin(q2 + q3 + q4 + q5) - m5 * l(2) * s(5) * Dq3 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq4 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq5 * sin(q3 + q4 + q5) - m5 * l(1) * s(5) * Dq2 * sin(q2 + q3 + q4 + q5) - m5 * l(3) * s(5) * Dq4 * sin(q4 + q5) - m5 * l(3) * s(5) * Dq5 * sin(q4 + q5) - m4 * l(2) * s(4) * Dq3 * sin(q3 + q4) - m4 * l(2) * s(4) * Dq4 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq3 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq4 * sin(q3 + q4) - m5 * l(1) * l(4) * Dq2 * sin(q2 + q3 + q4) - m5 * l(1) * l(4) * Dq4 * sin(q2 + q3 + q4) - m5 * l(1) * l(4) * Dq3 * sin(q2 + q3 + q4) - m4 * l(1) * s(4) * Dq2 * sin(q2 + q3 + q4) - m4 * l(1) * s(4) * Dq3 * sin(q2 + q3 + q4) - m4 * l(1) * s(4) * Dq4 * sin(q2 + q3 + q4) - m5 * l(4) * s(5) * sin(q5) * Dq5 - m5 * l(1) * l(3) * Dq2 * sin(q2 + q3) - m5 * l(1) * l(3) * Dq3 * sin(q2 + q3) - m3 * l(1) * l(3) * Dq2 * sin(q2 + q3) - m4 * l(3) * s(4) * sin(q4) * Dq4 - m5 * l(3) * l(4) * sin(q4) * Dq4 - m3 * l(1) * l(3) * Dq3 * sin(q2 + q3) + m3 * l(1) * s(3) * Dq2 * sin(q2 + q3) + m3 * l(1) * s(3) * Dq3 * sin(q2 + q3) - m4 * l(1) * l(3) * Dq2 * sin(q2 + q3) - m4 * l(1) * l(3) * Dq3 * sin(q2 + q3) - m4 * l(2) * l(3) * sin(q3) * Dq3 - m5 * l(2) * l(3) * sin(q3) * Dq3 - m3 * l(2) * l(3) * sin(q3) * Dq3 + m3 * l(2) * s(3) * sin(q3) * Dq3 - m5 * l(1) * l(2) * sin(q2) * Dq2 - m4 * l(1) * l(2) * sin(q2) * Dq2 - m2 * l(1) * l(2) * sin(q2) * Dq2 + m2 * l(1) * s(2) * sin(q2) * Dq2 - m3 * l(1) * l(2) * sin(q2) * Dq2 -m5 * l(1) * s(5) * Dq3 * sin(q2 + q3 + q4 + q5) - m5 * l(1) * s(5) * Dq4 * sin(q2 + q3 + q4 + q5) - m5 * l(1) * s(5) * Dq5 * sin(q2 + q3 + q4 + q5) - m5 * l(2) * s(5) * Dq3 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq4 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq5 * sin(q3 + q4 + q5) - m5 * l(1) * s(5) * Dq2 * sin(q2 + q3 + q4 + q5) - m5 * l(3) * s(5) * Dq4 * sin(q4 + q5) - m5 * l(3) * s(5) * Dq5 * sin(q4 + q5) - m4 * l(2) * s(4) * Dq3 * sin(q3 + q4) - m4 * l(2) * s(4) * Dq4 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq3 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq4 * sin(q3 + q4) - m5 * l(1) * l(4) * Dq2 * sin(q2 + q3 + q4) - m5 * l(1) * l(4) * Dq4 * sin(q2 + q3 + q4) - m5 * l(1) * l(4) * Dq3 * sin(q2 + q3 + q4) - m4 * l(1) * s(4) * Dq2 * sin(q2 + q3 + q4) - m4 * l(1) * s(4) * Dq3 * sin(q2 + q3 + q4) - m4 * l(1) * s(4) * Dq4 * sin(q2 + q3 + q4) - m5 * l(4) * s(5) * sin(q5) * Dq5 - m5 * l(1) * l(3) * Dq2 * sin(q2 + q3) - m5 * l(1) * l(3) * Dq3 * sin(q2 + q3) - m3 * l(1) * l(3) * Dq2 * sin(q2 + q3) - m4 * l(3) * s(4) * sin(q4) * Dq4 - m5 * l(3) * l(4) * sin(q4) * Dq4 - m3 * l(1) * l(3) * Dq3 * sin(q2 + q3) + m3 * l(1) * s(3) * Dq2 * sin(q2 + q3) + m3 * l(1) * s(3) * Dq3 * sin(q2 + q3) - m4 * l(1) * l(3) * Dq2 * sin(q2 + q3) - m4 * l(1) * l(3) * Dq3 * sin(q2 + q3) - m5 * Dq1 * l(1) * s(5) * sin(q2 + q3 + q4 + q5) - m5 * Dq1 * l(1) * l(4) * sin(q2 + q3 + q4) - m4 * Dq1 * l(1) * s(4) * sin(q2 + q3 + q4) - m3 * Dq1 * l(1) * l(3) * sin(q2 + q3) + m3 * Dq1 * l(1) * s(3) * sin(q2 + q3) - m5 * Dq1 * l(1) * l(3) * sin(q2 + q3) - m4 * Dq1 * l(1) * l(3) * sin(q2 + q3) - m3 * Dq1 * l(1) * l(2) * sin(q2) - m2 * Dq1 * l(1) * l(2) * sin(q2) - m5 * Dq1 * l(1) * l(2) * sin(q2) + m2 * Dq1 * l(1) * s(2) * sin(q2) - m4 * Dq1 * l(1) * l(2) * sin(q2) - m4 * l(2) * l(3) * sin(q3) * Dq3 - m5 * l(2) * l(3) * sin(q3) * Dq3 - m3 * l(2) * l(3) * sin(q3) * Dq3 + m3 * l(2) * s(3) * sin(q3) * Dq3 - m5 * l(1) * l(2) * sin(q2) * Dq2 - m4 * l(1) * l(2) * sin(q2) * Dq2 - m2 * l(1) * l(2) * sin(q2) * Dq2 + m2 * l(1) * s(2) * sin(q2) * Dq2 - m3 * l(1) * l(2) * sin(q2) * Dq2 -m5 * l(2) * s(5) * Dq2 * sin(q3 + q4 + q5) - m5 * l(1) * s(5) * Dq3 * sin(q2 + q3 + q4 + q5) - m5 * l(1) * s(5) * Dq4 * sin(q2 + q3 + q4 + q5) - m5 * l(1) * s(5) * Dq5 * sin(q2 + q3 + q4 + q5) - m5 * l(2) * s(5) * Dq3 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq4 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq5 * sin(q3 + q4 + q5) - m5 * l(1) * s(5) * Dq2 * sin(q2 + q3 + q4 + q5) - m5 * l(3) * s(5) * Dq4 * sin(q4 + q5) - m5 * l(3) * s(5) * Dq5 * sin(q4 + q5) - m4 * l(2) * s(4) * Dq2 * sin(q3 + q4) - m4 * l(2) * s(4) * Dq3 * sin(q3 + q4) - m4 * l(2) * s(4) * Dq4 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq2 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq3 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq4 * sin(q3 + q4) - m5 * l(1) * l(4) * Dq2 * sin(q2 + q3 + q4) - m5 * l(1) * l(4) * Dq4 * sin(q2 + q3 + q4) - m5 * l(1) * l(4) * Dq3 * sin(q2 + q3 + q4) - m4 * l(1) * s(4) * Dq2 * sin(q2 + q3 + q4) - m4 * l(1) * s(4) * Dq3 * sin(q2 + q3 + q4) - m4 * l(1) * s(4) * Dq4 * sin(q2 + q3 + q4) - m5 * l(4) * s(5) * sin(q5) * Dq5 - m4 * l(2) * l(3) * Dq2 * sin(q3) - m5 * l(2) * l(3) * Dq2 * sin(q3) - m5 * l(1) * l(3) * Dq2 * sin(q2 + q3) - m5 * l(1) * l(3) * Dq3 * sin(q2 + q3) + m3 * l(2) * s(3) * Dq2 * sin(q3) - m3 * l(1) * l(3) * Dq2 * sin(q2 + q3) - m4 * l(3) * s(4) * sin(q4) * Dq4 - m5 * l(3) * l(4) * sin(q4) * Dq4 - m3 * l(1) * l(3) * Dq3 * sin(q2 + q3) + m3 * l(1) * s(3) * Dq2 * sin(q2 + q3) + m3 * l(1) * s(3) * Dq3 * sin(q2 + q3) - m4 * l(1) * l(3) * Dq2 * sin(q2 + q3) - m4 * l(1) * l(3) * Dq3 * sin(q2 + q3) - m3 * l(2) * l(3) * Dq2 * sin(q3) - m5 * l(2) * Dq1 * s(5) * sin(q3 + q4 + q5) - m5 * Dq1 * l(1) * s(5) * sin(q2 + q3 + q4 + q5) - m5 * l(2) * Dq1 * l(4) * sin(q3 + q4) - m4 * l(2) * Dq1 * s(4) * sin(q3 + q4) - m5 * Dq1 * l(1) * l(4) * sin(q2 + q3 + q4) - m4 * Dq1 * l(1) * s(4) * sin(q2 + q3 + q4) - m5 * l(2) * Dq1 * l(3) * sin(q3) - m3 * Dq1 * l(1) * l(3) * sin(q2 + q3) + m3 * Dq1 * l(1) * s(3) * sin(q2 + q3) - m4 * l(2) * Dq1 * l(3) * sin(q3) - m5 * Dq1 * l(1) * l(3) * sin(q2 + q3) - m3 * l(2) * Dq1 * l(3) * sin(q3) + m3 * l(2) * Dq1 * s(3) * sin(q3) - m4 * Dq1 * l(1) * l(3) * sin(q2 + q3) - m4 * l(2) * l(3) * sin(q3) * Dq3 - m5 * l(2) * l(3) * sin(q3) * Dq3 - m3 * l(2) * l(3) * sin(q3) * Dq3 + m3 * l(2) * s(3) * sin(q3) * Dq3 -m5 * l(3) * s(5) * Dq3 * sin(q4 + q5) - m5 * l(3) * s(5) * Dq2 * sin(q4 + q5) - m5 * l(2) * s(5) * Dq2 * sin(q3 + q4 + q5) - m5 * l(1) * s(5) * Dq3 * sin(q2 + q3 + q4 + q5) - m5 * l(1) * s(5) * Dq4 * sin(q2 + q3 + q4 + q5) - m5 * l(1) * s(5) * Dq5 * sin(q2 + q3 + q4 + q5) - m5 * l(2) * s(5) * Dq3 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq4 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq5 * sin(q3 + q4 + q5) - m5 * l(1) * s(5) * Dq2 * sin(q2 + q3 + q4 + q5) - m5 * l(3) * s(5) * Dq4 * sin(q4 + q5) - m5 * l(3) * s(5) * Dq5 * sin(q4 + q5) - m5 * l(3) * l(4) * Dq2 * sin(q4) - m4 * l(2) * s(4) * Dq2 * sin(q3 + q4) - m4 * l(2) * s(4) * Dq3 * sin(q3 + q4) - m4 * l(2) * s(4) * Dq4 * sin(q3 + q4) - m5 * l(3) * l(4) * Dq3 * sin(q4) - m4 * l(3) * s(4) * Dq2 * sin(q4) - m4 * l(3) * s(4) * Dq3 * sin(q4) - m5 * l(2) * l(4) * Dq2 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq3 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq4 * sin(q3 + q4) - m5 * l(1) * l(4) * Dq2 * sin(q2 + q3 + q4) - m5 * l(1) * l(4) * Dq4 * sin(q2 + q3 + q4) - m5 * l(1) * l(4) * Dq3 * sin(q2 + q3 + q4) - m4 * l(1) * s(4) * Dq2 * sin(q2 + q3 + q4) - m4 * l(1) * s(4) * Dq3 * sin(q2 + q3 + q4) - m4 * l(1) * s(4) * Dq4 * sin(q2 + q3 + q4) - m5 * l(4) * s(5) * sin(q5) * Dq5 - m4 * l(3) * s(4) * sin(q4) * Dq4 - m5 * l(3) * l(4) * sin(q4) * Dq4 - m5 * l(2) * Dq1 * s(5) * sin(q3 + q4 + q5) - m5 * Dq1 * l(1) * s(5) * sin(q2 + q3 + q4 + q5) - m5 * l(3) * Dq1 * s(5) * sin(q4 + q5) - m5 * l(2) * Dq1 * l(4) * sin(q3 + q4) - m4 * l(3) * Dq1 * s(4) * sin(q4) - m4 * l(2) * Dq1 * s(4) * sin(q3 + q4) - m5 * Dq1 * l(1) * l(4) * sin(q2 + q3 + q4) - m4 * Dq1 * l(1) * s(4) * sin(q2 + q3 + q4) - m5 * l(3) * Dq1 * l(4) * sin(q4) -m5 * s(5) * (l(4) * sin(q5) * Dq5 + l(3) * Dq1 * sin(q4 + q5) + l(3) * Dq2 * sin(q4 + q5) + l(4) * Dq1 * sin(q5) + l(3) * Dq3 * sin(q4 + q5) + l(3) * Dq4 * sin(q4 + q5) + l(3) * Dq5 * sin(q4 + q5) + l(4) * Dq2 * sin(q5) + l(4) * Dq3 * sin(q5) + l(4) * Dq4 * sin(q5) + l(2) * Dq1 * sin(q3 + q4 + q5) + l(2) * Dq2 * sin(q3 + q4 + q5) + l(2) * Dq3 * sin(q3 + q4 + q5) + l(2) * Dq4 * sin(q3 + q4 + q5) + l(2) * Dq5 * sin(q3 + q4 + q5) + l(1) * Dq3 * sin(q2 + q3 + q4 + q5) + l(1) * Dq4 * sin(q2 + q3 + q4 + q5) + l(1) * Dq5 * sin(q2 + q3 + q4 + q5) + l(1) * Dq2 * sin(q2 + q3 + q4 + q5) + Dq1 * l(1) * sin(q2 + q3 + q4 + q5)) 0 0; -m5 * l(2) * s(5) * Dq3 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq4 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq5 * sin(q3 + q4 + q5) - m5 * l(3) * s(5) * Dq4 * sin(q4 + q5) - m5 * l(3) * s(5) * Dq5 * sin(q4 + q5) - m4 * l(2) * s(4) * Dq3 * sin(q3 + q4) - m4 * l(2) * s(4) * Dq4 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq3 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq4 * sin(q3 + q4) - m5 * l(4) * s(5) * sin(q5) * Dq5 - m4 * l(3) * s(4) * sin(q4) * Dq4 - m5 * l(3) * l(4) * sin(q4) * Dq4 + m5 * Dq1 * l(1) * s(5) * sin(q2 + q3 + q4 + q5) + m5 * Dq1 * l(1) * l(4) * sin(q2 + q3 + q4) + m4 * Dq1 * l(1) * s(4) * sin(q2 + q3 + q4) + m3 * Dq1 * l(1) * l(3) * sin(q2 + q3) - m3 * Dq1 * l(1) * s(3) * sin(q2 + q3) + m5 * Dq1 * l(1) * l(3) * sin(q2 + q3) + m4 * Dq1 * l(1) * l(3) * sin(q2 + q3) + m3 * Dq1 * l(1) * l(2) * sin(q2) + m2 * Dq1 * l(1) * l(2) * sin(q2) + m5 * Dq1 * l(1) * l(2) * sin(q2) - m2 * Dq1 * l(1) * s(2) * sin(q2) + m4 * Dq1 * l(1) * l(2) * sin(q2) - m4 * l(2) * l(3) * sin(q3) * Dq3 - m5 * l(2) * l(3) * sin(q3) * Dq3 - m3 * l(2) * l(3) * sin(q3) * Dq3 + m3 * l(2) * s(3) * sin(q3) * Dq3 -m5 * l(2) * s(5) * Dq3 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq4 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq5 * sin(q3 + q4 + q5) - m5 * l(3) * s(5) * Dq4 * sin(q4 + q5) - m5 * l(3) * s(5) * Dq5 * sin(q4 + q5) - m4 * l(2) * s(4) * Dq3 * sin(q3 + q4) - m4 * l(2) * s(4) * Dq4 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq3 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq4 * sin(q3 + q4) - m5 * l(4) * s(5) * sin(q5) * Dq5 - m4 * l(3) * s(4) * sin(q4) * Dq4 - m5 * l(3) * l(4) * sin(q4) * Dq4 - m4 * l(2) * l(3) * sin(q3) * Dq3 - m5 * l(2) * l(3) * sin(q3) * Dq3 - m3 * l(2) * l(3) * sin(q3) * Dq3 + m3 * l(2) * s(3) * sin(q3) * Dq3 -m5 * l(2) * s(5) * Dq2 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq3 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq4 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq5 * sin(q3 + q4 + q5) - m5 * l(3) * s(5) * Dq4 * sin(q4 + q5) - m5 * l(3) * s(5) * Dq5 * sin(q4 + q5) - m4 * l(2) * s(4) * Dq2 * sin(q3 + q4) - m4 * l(2) * s(4) * Dq3 * sin(q3 + q4) - m4 * l(2) * s(4) * Dq4 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq2 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq3 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq4 * sin(q3 + q4) - m5 * l(4) * s(5) * sin(q5) * Dq5 - m4 * l(2) * l(3) * Dq2 * sin(q3) - m5 * l(2) * l(3) * Dq2 * sin(q3) + m3 * l(2) * s(3) * Dq2 * sin(q3) - m4 * l(3) * s(4) * sin(q4) * Dq4 - m5 * l(3) * l(4) * sin(q4) * Dq4 - m3 * l(2) * l(3) * Dq2 * sin(q3) - m5 * l(2) * Dq1 * s(5) * sin(q3 + q4 + q5) - m5 * l(2) * Dq1 * l(4) * sin(q3 + q4) - m4 * l(2) * Dq1 * s(4) * sin(q3 + q4) - m5 * l(2) * Dq1 * l(3) * sin(q3) - m4 * l(2) * Dq1 * l(3) * sin(q3) - m3 * l(2) * Dq1 * l(3) * sin(q3) + m3 * l(2) * Dq1 * s(3) * sin(q3) - m4 * l(2) * l(3) * sin(q3) * Dq3 - m5 * l(2) * l(3) * sin(q3) * Dq3 - m3 * l(2) * l(3) * sin(q3) * Dq3 + m3 * l(2) * s(3) * sin(q3) * Dq3 -m5 * l(3) * s(5) * Dq3 * sin(q4 + q5) - m5 * l(3) * s(5) * Dq2 * sin(q4 + q5) - m5 * l(2) * s(5) * Dq2 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq3 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq4 * sin(q3 + q4 + q5) - m5 * l(2) * s(5) * Dq5 * sin(q3 + q4 + q5) - m5 * l(3) * s(5) * Dq4 * sin(q4 + q5) - m5 * l(3) * s(5) * Dq5 * sin(q4 + q5) - m5 * l(3) * l(4) * Dq2 * sin(q4) - m4 * l(2) * s(4) * Dq2 * sin(q3 + q4) - m4 * l(2) * s(4) * Dq3 * sin(q3 + q4) - m4 * l(2) * s(4) * Dq4 * sin(q3 + q4) - m5 * l(3) * l(4) * Dq3 * sin(q4) - m4 * l(3) * s(4) * Dq2 * sin(q4) - m4 * l(3) * s(4) * Dq3 * sin(q4) - m5 * l(2) * l(4) * Dq2 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq3 * sin(q3 + q4) - m5 * l(2) * l(4) * Dq4 * sin(q3 + q4) - m5 * l(4) * s(5) * sin(q5) * Dq5 - m4 * l(3) * s(4) * sin(q4) * Dq4 - m5 * l(3) * l(4) * sin(q4) * Dq4 - m5 * l(2) * Dq1 * s(5) * sin(q3 + q4 + q5) - m5 * l(3) * Dq1 * s(5) * sin(q4 + q5) - m5 * l(2) * Dq1 * l(4) * sin(q3 + q4) - m4 * l(3) * Dq1 * s(4) * sin(q4) - m4 * l(2) * Dq1 * s(4) * sin(q3 + q4) - m5 * l(3) * Dq1 * l(4) * sin(q4) -m5 * s(5) * (l(4) * sin(q5) * Dq5 + l(2) * Dq1 * sin(q3 + q4 + q5) + l(3) * Dq1 * sin(q4 + q5) + l(3) * Dq2 * sin(q4 + q5) + l(4) * Dq1 * sin(q5) + l(3) * Dq3 * sin(q4 + q5) + l(3) * Dq4 * sin(q4 + q5) + l(3) * Dq5 * sin(q4 + q5) + l(4) * Dq2 * sin(q5) + l(4) * Dq3 * sin(q5) + l(4) * Dq4 * sin(q5) + l(2) * Dq2 * sin(q3 + q4 + q5) + l(2) * Dq3 * sin(q3 + q4 + q5) + l(2) * Dq4 * sin(q3 + q4 + q5) + l(2) * Dq5 * sin(q3 + q4 + q5)) 0 0; m5 * l(2) * s(5) * Dq2 * sin(q3 + q4 + q5) - m5 * l(3) * s(5) * Dq4 * sin(q4 + q5) - m5 * l(3) * s(5) * Dq5 * sin(q4 + q5) + m4 * l(2) * s(4) * Dq2 * sin(q3 + q4) + m5 * l(2) * l(4) * Dq2 * sin(q3 + q4) - m5 * l(4) * s(5) * sin(q5) * Dq5 + m4 * l(2) * l(3) * Dq2 * sin(q3) + m5 * l(2) * l(3) * Dq2 * sin(q3) - m3 * l(2) * s(3) * Dq2 * sin(q3) - m4 * l(3) * s(4) * sin(q4) * Dq4 - m5 * l(3) * l(4) * sin(q4) * Dq4 + m3 * l(2) * l(3) * Dq2 * sin(q3) + m5 * l(2) * Dq1 * s(5) * sin(q3 + q4 + q5) + m5 * Dq1 * l(1) * s(5) * sin(q2 + q3 + q4 + q5) + m5 * l(2) * Dq1 * l(4) * sin(q3 + q4) + m4 * l(2) * Dq1 * s(4) * sin(q3 + q4) + m5 * Dq1 * l(1) * l(4) * sin(q2 + q3 + q4) + m4 * Dq1 * l(1) * s(4) * sin(q2 + q3 + q4) + m5 * l(2) * Dq1 * l(3) * sin(q3) + m3 * Dq1 * l(1) * l(3) * sin(q2 + q3) - m3 * Dq1 * l(1) * s(3) * sin(q2 + q3) + m4 * l(2) * Dq1 * l(3) * sin(q3) + m5 * Dq1 * l(1) * l(3) * sin(q2 + q3) + m3 * l(2) * Dq1 * l(3) * sin(q3) - m3 * l(2) * Dq1 * s(3) * sin(q3) + m4 * Dq1 * l(1) * l(3) * sin(q2 + q3) m4 * l(2) * l(3) * Dq2 * sin(q3) + m5 * l(2) * l(3) * Dq2 * sin(q3) - m3 * l(2) * s(3) * Dq2 * sin(q3) + m3 * l(2) * l(3) * Dq2 * sin(q3) + m5 * l(2) * Dq1 * l(3) * sin(q3) + m4 * l(2) * Dq1 * l(3) * sin(q3) + m3 * l(2) * Dq1 * l(3) * sin(q3) - m3 * l(2) * Dq1 * s(3) * sin(q3) - m5 * l(4) * s(5) * sin(q5) * Dq5 - m5 * l(3) * s(5) * Dq4 * sin(q4 + q5) - m5 * l(3) * s(5) * Dq5 * sin(q4 + q5) + m5 * l(2) * Dq1 * s(5) * sin(q3 + q4 + q5) + m5 * l(2) * s(5) * Dq2 * sin(q3 + q4 + q5) + m4 * l(2) * s(4) * Dq2 * sin(q3 + q4) + m5 * l(2) * l(4) * Dq2 * sin(q3 + q4) + m5 * l(2) * Dq1 * l(4) * sin(q3 + q4) + m4 * l(2) * Dq1 * s(4) * sin(q3 + q4) - m4 * l(3) * s(4) * sin(q4) * Dq4 - m5 * l(3) * l(4) * sin(q4) * Dq4 -m5 * l(3) * s(5) * Dq4 * sin(q4 + q5) - m5 * l(3) * s(5) * Dq5 * sin(q4 + q5) - m5 * l(4) * s(5) * sin(q5) * Dq5 - m4 * l(3) * s(4) * sin(q4) * Dq4 - m5 * l(3) * l(4) * sin(q4) * Dq4 -m5 * l(3) * s(5) * Dq3 * sin(q4 + q5) - m5 * l(3) * s(5) * Dq2 * sin(q4 + q5) - m5 * l(3) * s(5) * Dq4 * sin(q4 + q5) - m5 * l(3) * s(5) * Dq5 * sin(q4 + q5) - m5 * l(3) * l(4) * Dq2 * sin(q4) - m5 * l(3) * l(4) * Dq3 * sin(q4) - m4 * l(3) * s(4) * Dq2 * sin(q4) - m4 * l(3) * s(4) * Dq3 * sin(q4) - m5 * l(4) * s(5) * sin(q5) * Dq5 - m4 * l(3) * s(4) * sin(q4) * Dq4 - m5 * l(3) * l(4) * sin(q4) * Dq4 - m5 * l(3) * Dq1 * s(5) * sin(q4 + q5) - m4 * l(3) * Dq1 * s(4) * sin(q4) - m5 * l(3) * Dq1 * l(4) * sin(q4) -m5 * s(5) * (l(4) * sin(q5) * Dq5 + l(3) * Dq1 * sin(q4 + q5) + l(3) * Dq2 * sin(q4 + q5) + l(4) * Dq1 * sin(q5) + l(3) * Dq3 * sin(q4 + q5) + l(3) * Dq4 * sin(q4 + q5) + l(3) * Dq5 * sin(q4 + q5) + l(4) * Dq2 * sin(q5) + l(4) * Dq3 * sin(q5) + l(4) * Dq4 * sin(q5)) 0 0; -m5 * l(4) * s(5) * sin(q5) * Dq5 + m5 * l(3) * Dq1 * s(5) * sin(q4 + q5) + m5 * l(3) * s(5) * Dq2 * sin(q4 + q5) + m5 * l(3) * s(5) * Dq3 * sin(q4 + q5) + m5 * l(2) * Dq1 * s(5) * sin(q3 + q4 + q5) + m5 * l(2) * s(5) * Dq2 * sin(q3 + q4 + q5) + m5 * Dq1 * l(1) * s(5) * sin(q2 + q3 + q4 + q5) + m5 * Dq1 * l(1) * l(4) * sin(q2 + q3 + q4) + m4 * Dq1 * l(1) * s(4) * sin(q2 + q3 + q4) + m4 * l(2) * s(4) * Dq2 * sin(q3 + q4) + m5 * l(2) * l(4) * Dq2 * sin(q3 + q4) + m5 * l(2) * Dq1 * l(4) * sin(q3 + q4) + m4 * l(2) * Dq1 * s(4) * sin(q3 + q4) + m5 * l(3) * l(4) * Dq2 * sin(q4) + m5 * l(3) * l(4) * Dq3 * sin(q4) + m4 * l(3) * s(4) * Dq2 * sin(q4) + m4 * l(3) * s(4) * Dq3 * sin(q4) + m4 * l(3) * Dq1 * s(4) * sin(q4) + m5 * l(3) * Dq1 * l(4) * sin(q4) -m5 * l(4) * s(5) * sin(q5) * Dq5 + m5 * l(3) * Dq1 * s(5) * sin(q4 + q5) + m5 * l(3) * s(5) * Dq2 * sin(q4 + q5) + m5 * l(3) * s(5) * Dq3 * sin(q4 + q5) + m5 * l(2) * Dq1 * s(5) * sin(q3 + q4 + q5) + m5 * l(2) * s(5) * Dq2 * sin(q3 + q4 + q5) + m4 * l(2) * s(4) * Dq2 * sin(q3 + q4) + m5 * l(2) * l(4) * Dq2 * sin(q3 + q4) + m5 * l(2) * Dq1 * l(4) * sin(q3 + q4) + m4 * l(2) * Dq1 * s(4) * sin(q3 + q4) + m5 * l(3) * l(4) * Dq2 * sin(q4) + m5 * l(3) * l(4) * Dq3 * sin(q4) + m4 * l(3) * s(4) * Dq2 * sin(q4) + m4 * l(3) * s(4) * Dq3 * sin(q4) + m4 * l(3) * Dq1 * s(4) * sin(q4) + m5 * l(3) * Dq1 * l(4) * sin(q4) m5 * l(3) * s(5) * Dq3 * sin(q4 + q5) + m5 * l(3) * s(5) * Dq2 * sin(q4 + q5) + m5 * l(3) * l(4) * Dq2 * sin(q4) + m5 * l(3) * l(4) * Dq3 * sin(q4) + m4 * l(3) * s(4) * Dq2 * sin(q4) + m4 * l(3) * s(4) * Dq3 * sin(q4) - m5 * l(4) * s(5) * sin(q5) * Dq5 + m5 * l(3) * Dq1 * s(5) * sin(q4 + q5) + m4 * l(3) * Dq1 * s(4) * sin(q4) + m5 * l(3) * Dq1 * l(4) * sin(q4) -m5 * l(4) * s(5) * sin(q5) * Dq5 -m5 * l(4) * s(5) * sin(q5) * (Dq1 + Dq2 + Dq3 + Dq4 + Dq5) 0 0; m5 * s(5) * (l(3) * Dq1 * sin(q4 + q5) + l(3) * Dq2 * sin(q4 + q5) + l(4) * Dq1 * sin(q5) + l(3) * Dq3 * sin(q4 + q5) + l(4) * Dq2 * sin(q5) + l(4) * Dq3 * sin(q5) + l(4) * Dq4 * sin(q5) + l(2) * Dq1 * sin(q3 + q4 + q5) + l(2) * Dq2 * sin(q3 + q4 + q5) + Dq1 * l(1) * sin(q2 + q3 + q4 + q5)) m5 * s(5) * (l(2) * Dq2 * sin(q3 + q4 + q5) + l(3) * Dq1 * sin(q4 + q5) + l(4) * Dq3 * sin(q5) + l(4) * Dq4 * sin(q5) + l(2) * Dq1 * sin(q3 + q4 + q5) + l(4) * Dq1 * sin(q5) + l(3) * Dq3 * sin(q4 + q5) + l(4) * Dq2 * sin(q5) + l(3) * Dq2 * sin(q4 + q5)) m5 * s(5) * (l(3) * Dq1 * sin(q4 + q5) + l(4) * Dq2 * sin(q5) + l(4) * Dq4 * sin(q5) + l(4) * Dq1 * sin(q5) + l(3) * Dq2 * sin(q4 + q5) + l(4) * Dq3 * sin(q5) + l(3) * Dq3 * sin(q4 + q5)) m5 * l(4) * s(5) * sin(q5) * (Dq1 + Dq2 + Dq3 + Dq4) 0 0 0; -m4 * cos(q1 + q2) * l(2) * Dq2 - m4 * cos(q1 + q2 + q3) * l(3) * Dq1 - m4 * cos(q1 + q2 + q3) * l(3) * Dq2 - m4 * cos(q1 + q2 + q3) * l(3) * Dq3 - m4 * s(4) * cos(q1 + q2 + q3 + q4) * Dq1 - m4 * s(4) * cos(q1 + q2 + q3 + q4) * Dq2 - m4 * s(4) * cos(q1 + q2 + q3 + q4) * Dq3 - m4 * s(4) * cos(q1 + q2 + q3 + q4) * Dq4 - m5 * cos(q1) * Dq1 * l(1) - m5 * cos(q1 + q2) * l(2) * Dq1 - m5 * cos(q1 + q2) * l(2) * Dq2 - m5 * cos(q1 + q2 + q3) * l(3) * Dq1 - m5 * cos(q1 + q2 + q3) * l(3) * Dq2 - m5 * cos(q1 + q2 + q3) * l(3) * Dq3 - m5 * l(4) * cos(q1 + q2 + q3 + q4) * Dq1 - m5 * l(4) * cos(q1 + q2 + q3 + q4) * Dq2 - m5 * l(4) * cos(q1 + q2 + q3 + q4) * Dq3 - m5 * l(4) * cos(q1 + q2 + q3 + q4) * Dq4 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq1 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq2 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq3 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq4 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq5 - m1 * cos(q1) * Dq1 * l(1) + m1 * cos(q1) * Dq1 * s(1) - m2 * cos(q1) * Dq1 * l(1) - m2 * cos(q1 + q2) * l(2) * Dq1 - m2 * cos(q1 + q2) * l(2) * Dq2 + m2 * cos(q1 + q2) * s(2) * Dq1 + m2 * cos(q1 + q2) * s(2) * Dq2 - m3 * cos(q1) * Dq1 * l(1) - m3 * cos(q1 + q2) * l(2) * Dq1 - m3 * cos(q1 + q2) * l(2) * Dq2 - m3 * cos(q1 + q2 + q3) * l(3) * Dq1 - m3 * cos(q1 + q2 + q3) * l(3) * Dq2 - m3 * cos(q1 + q2 + q3) * l(3) * Dq3 + m3 * cos(q1 + q2 + q3) * s(3) * Dq1 + m3 * cos(q1 + q2 + q3) * s(3) * Dq2 + m3 * cos(q1 + q2 + q3) * s(3) * Dq3 - m4 * cos(q1) * Dq1 * l(1) - m4 * cos(q1 + q2) * l(2) * Dq1 -m4 * cos(q1 + q2) * l(2) * Dq2 - m4 * cos(q1 + q2 + q3) * l(3) * Dq1 - m4 * cos(q1 + q2 + q3) * l(3) * Dq2 - m4 * cos(q1 + q2 + q3) * l(3) * Dq3 - m4 * s(4) * cos(q1 + q2 + q3 + q4) * Dq1 - m4 * s(4) * cos(q1 + q2 + q3 + q4) * Dq2 - m4 * s(4) * cos(q1 + q2 + q3 + q4) * Dq3 - m4 * s(4) * cos(q1 + q2 + q3 + q4) * Dq4 - m5 * cos(q1 + q2) * l(2) * Dq1 - m5 * cos(q1 + q2) * l(2) * Dq2 - m5 * cos(q1 + q2 + q3) * l(3) * Dq1 - m5 * cos(q1 + q2 + q3) * l(3) * Dq2 - m5 * cos(q1 + q2 + q3) * l(3) * Dq3 - m5 * l(4) * cos(q1 + q2 + q3 + q4) * Dq1 - m5 * l(4) * cos(q1 + q2 + q3 + q4) * Dq2 - m5 * l(4) * cos(q1 + q2 + q3 + q4) * Dq3 - m5 * l(4) * cos(q1 + q2 + q3 + q4) * Dq4 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq1 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq2 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq3 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq4 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq5 - m2 * cos(q1 + q2) * l(2) * Dq1 - m2 * cos(q1 + q2) * l(2) * Dq2 + m2 * cos(q1 + q2) * s(2) * Dq1 + m2 * cos(q1 + q2) * s(2) * Dq2 - m3 * cos(q1 + q2) * l(2) * Dq1 - m3 * cos(q1 + q2) * l(2) * Dq2 - m3 * cos(q1 + q2 + q3) * l(3) * Dq1 - m3 * cos(q1 + q2 + q3) * l(3) * Dq2 - m3 * cos(q1 + q2 + q3) * l(3) * Dq3 + m3 * cos(q1 + q2 + q3) * s(3) * Dq1 + m3 * cos(q1 + q2 + q3) * s(3) * Dq2 + m3 * cos(q1 + q2 + q3) * s(3) * Dq3 - m4 * cos(q1 + q2) * l(2) * Dq1 -m4 * cos(q1 + q2 + q3) * l(3) * Dq1 - m4 * cos(q1 + q2 + q3) * l(3) * Dq2 - m4 * cos(q1 + q2 + q3) * l(3) * Dq3 - m4 * s(4) * cos(q1 + q2 + q3 + q4) * Dq1 - m4 * s(4) * cos(q1 + q2 + q3 + q4) * Dq2 - m4 * s(4) * cos(q1 + q2 + q3 + q4) * Dq3 - m4 * s(4) * cos(q1 + q2 + q3 + q4) * Dq4 - m5 * cos(q1 + q2 + q3) * l(3) * Dq1 - m5 * cos(q1 + q2 + q3) * l(3) * Dq2 - m5 * cos(q1 + q2 + q3) * l(3) * Dq3 - m5 * l(4) * cos(q1 + q2 + q3 + q4) * Dq1 - m5 * l(4) * cos(q1 + q2 + q3 + q4) * Dq2 - m5 * l(4) * cos(q1 + q2 + q3 + q4) * Dq3 - m5 * l(4) * cos(q1 + q2 + q3 + q4) * Dq4 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq1 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq2 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq3 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq4 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq5 - m3 * cos(q1 + q2 + q3) * l(3) * Dq1 - m3 * cos(q1 + q2 + q3) * l(3) * Dq2 - m3 * cos(q1 + q2 + q3) * l(3) * Dq3 + m3 * cos(q1 + q2 + q3) * s(3) * Dq1 + m3 * cos(q1 + q2 + q3) * s(3) * Dq2 + m3 * cos(q1 + q2 + q3) * s(3) * Dq3 -m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq1 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq2 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq3 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq4 - m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * Dq5 - m5 * l(4) * cos(q1 + q2 + q3 + q4) * Dq1 - m5 * l(4) * cos(q1 + q2 + q3 + q4) * Dq2 - m5 * l(4) * cos(q1 + q2 + q3 + q4) * Dq3 - m5 * l(4) * cos(q1 + q2 + q3 + q4) * Dq4 - m4 * s(4) * cos(q1 + q2 + q3 + q4) * Dq1 - m4 * s(4) * cos(q1 + q2 + q3 + q4) * Dq2 - m4 * s(4) * cos(q1 + q2 + q3 + q4) * Dq3 - m4 * s(4) * cos(q1 + q2 + q3 + q4) * Dq4 -m5 * s(5) * cos(q1 + q2 + q3 + q4 + q5) * (Dq1 + Dq2 + Dq3 + Dq4 + Dq5) 0 0; m1 * sin(q1) * Dq1 * s(1) - m1 * sin(q1) * Dq1 * l(1) - m2 * sin(q1) * Dq1 * l(1) - m2 * sin(q1 + q2) * l(2) * Dq1 - m2 * sin(q1 + q2) * l(2) * Dq2 + m2 * sin(q1 + q2) * s(2) * Dq1 + m2 * sin(q1 + q2) * s(2) * Dq2 - m3 * sin(q1) * Dq1 * l(1) - m3 * sin(q1 + q2) * l(2) * Dq1 - m3 * sin(q1 + q2) * l(2) * Dq2 - m3 * sin(q1 + q2 + q3) * l(3) * Dq1 - m3 * sin(q1 + q2 + q3) * l(3) * Dq2 - m3 * sin(q1 + q2 + q3) * l(3) * Dq3 + m3 * sin(q1 + q2 + q3) * s(3) * Dq1 + m3 * sin(q1 + q2 + q3) * s(3) * Dq2 + m3 * sin(q1 + q2 + q3) * s(3) * Dq3 - m4 * sin(q1) * Dq1 * l(1) - m4 * sin(q1 + q2) * l(2) * Dq1 - m4 * sin(q1 + q2) * l(2) * Dq2 - m4 * sin(q1 + q2 + q3) * l(3) * Dq1 - m4 * sin(q1 + q2 + q3) * l(3) * Dq2 - m4 * sin(q1 + q2 + q3) * l(3) * Dq3 - m4 * s(4) * sin(q1 + q2 + q3 + q4) * Dq1 - m4 * s(4) * sin(q1 + q2 + q3 + q4) * Dq2 - m4 * s(4) * sin(q1 + q2 + q3 + q4) * Dq3 - m4 * s(4) * sin(q1 + q2 + q3 + q4) * Dq4 - m5 * sin(q1 + q2) * l(2) * Dq1 - m5 * sin(q1 + q2) * l(2) * Dq2 - m5 * sin(q1 + q2 + q3) * l(3) * Dq1 - m5 * sin(q1 + q2 + q3) * l(3) * Dq2 - m5 * sin(q1 + q2 + q3) * l(3) * Dq3 - m5 * l(4) * sin(q1 + q2 + q3 + q4) * Dq1 - m5 * l(4) * sin(q1 + q2 + q3 + q4) * Dq2 - m5 * l(4) * sin(q1 + q2 + q3 + q4) * Dq3 - m5 * l(4) * sin(q1 + q2 + q3 + q4) * Dq4 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq1 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq2 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq3 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq4 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq5 - m5 * sin(q1) * Dq1 * l(1) -m2 * sin(q1 + q2) * l(2) * Dq1 - m2 * sin(q1 + q2) * l(2) * Dq2 + m2 * sin(q1 + q2) * s(2) * Dq1 + m2 * sin(q1 + q2) * s(2) * Dq2 - m3 * sin(q1 + q2) * l(2) * Dq1 - m3 * sin(q1 + q2) * l(2) * Dq2 - m3 * sin(q1 + q2 + q3) * l(3) * Dq1 - m3 * sin(q1 + q2 + q3) * l(3) * Dq2 - m3 * sin(q1 + q2 + q3) * l(3) * Dq3 + m3 * sin(q1 + q2 + q3) * s(3) * Dq1 + m3 * sin(q1 + q2 + q3) * s(3) * Dq2 + m3 * sin(q1 + q2 + q3) * s(3) * Dq3 - m4 * sin(q1 + q2) * l(2) * Dq1 - m4 * sin(q1 + q2) * l(2) * Dq2 - m4 * sin(q1 + q2 + q3) * l(3) * Dq1 - m4 * sin(q1 + q2 + q3) * l(3) * Dq2 - m4 * sin(q1 + q2 + q3) * l(3) * Dq3 - m4 * s(4) * sin(q1 + q2 + q3 + q4) * Dq1 - m4 * s(4) * sin(q1 + q2 + q3 + q4) * Dq2 - m4 * s(4) * sin(q1 + q2 + q3 + q4) * Dq3 - m4 * s(4) * sin(q1 + q2 + q3 + q4) * Dq4 - m5 * sin(q1 + q2) * l(2) * Dq1 - m5 * sin(q1 + q2) * l(2) * Dq2 - m5 * sin(q1 + q2 + q3) * l(3) * Dq1 - m5 * sin(q1 + q2 + q3) * l(3) * Dq2 - m5 * sin(q1 + q2 + q3) * l(3) * Dq3 - m5 * l(4) * sin(q1 + q2 + q3 + q4) * Dq1 - m5 * l(4) * sin(q1 + q2 + q3 + q4) * Dq2 - m5 * l(4) * sin(q1 + q2 + q3 + q4) * Dq3 - m5 * l(4) * sin(q1 + q2 + q3 + q4) * Dq4 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq1 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq2 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq3 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq4 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq5 -m3 * sin(q1 + q2 + q3) * l(3) * Dq1 - m3 * sin(q1 + q2 + q3) * l(3) * Dq2 - m3 * sin(q1 + q2 + q3) * l(3) * Dq3 + m3 * sin(q1 + q2 + q3) * s(3) * Dq1 + m3 * sin(q1 + q2 + q3) * s(3) * Dq2 + m3 * sin(q1 + q2 + q3) * s(3) * Dq3 - m4 * sin(q1 + q2 + q3) * l(3) * Dq1 - m4 * sin(q1 + q2 + q3) * l(3) * Dq2 - m4 * sin(q1 + q2 + q3) * l(3) * Dq3 - m4 * s(4) * sin(q1 + q2 + q3 + q4) * Dq1 - m4 * s(4) * sin(q1 + q2 + q3 + q4) * Dq2 - m4 * s(4) * sin(q1 + q2 + q3 + q4) * Dq3 - m4 * s(4) * sin(q1 + q2 + q3 + q4) * Dq4 - m5 * sin(q1 + q2 + q3) * l(3) * Dq1 - m5 * sin(q1 + q2 + q3) * l(3) * Dq2 - m5 * sin(q1 + q2 + q3) * l(3) * Dq3 - m5 * l(4) * sin(q1 + q2 + q3 + q4) * Dq1 - m5 * l(4) * sin(q1 + q2 + q3 + q4) * Dq2 - m5 * l(4) * sin(q1 + q2 + q3 + q4) * Dq3 - m5 * l(4) * sin(q1 + q2 + q3 + q4) * Dq4 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq1 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq2 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq3 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq4 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq5 -m5 * l(4) * sin(q1 + q2 + q3 + q4) * Dq2 - m5 * l(4) * sin(q1 + q2 + q3 + q4) * Dq3 - m5 * l(4) * sin(q1 + q2 + q3 + q4) * Dq4 - m4 * s(4) * sin(q1 + q2 + q3 + q4) * Dq1 - m4 * s(4) * sin(q1 + q2 + q3 + q4) * Dq2 - m4 * s(4) * sin(q1 + q2 + q3 + q4) * Dq3 - m4 * s(4) * sin(q1 + q2 + q3 + q4) * Dq4 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq1 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq2 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq3 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq4 - m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * Dq5 - m5 * l(4) * sin(q1 + q2 + q3 + q4) * Dq1 -m5 * s(5) * sin(q1 + q2 + q3 + q4 + q5) * (Dq1 + Dq2 + Dq3 + Dq4 + Dq5) 0 0;];

Eext = [0 0 0 0; 0 0 0 1;];

y = Mext * DDq + Cext * Dq + Gext';
out = y(7);



end

